         /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include 		"SMain.h"
#include 		"XMain.h"


/* X staff */
XtAppContext		app;
Display			*dpy;
Colormap 		Cmap;

XColor 			Cred,Cblue,
			Cgreen,
			Cblack,
			Cgray,
			Cwhite;

XGCValues 		gcv;

GC 			redgc,
			bluegc,
			greengc,
			blackgc,
			graygc,
			whitegc;

Widget			toplevel, 	/* the toplevel widget */
			Wpar,
			Wbox,		/* the toplevel box form */

			AboutButton,	/*Control Panel belongs to the toplevel, box*/
			SetupButton,
			InputButton,
			TrainingButton,
			RunningButton,
			SaveButton,
			QuitButton, 	/* above are the Buttons of the control panel */
			ParametersButton,
	
			AboutPopup,
			AboutForm,

			SetupPopup,	/* THE SETUP SUB MENU BELONGS TO THE TOPLEVEL */
			SetupForm,	/* the form widget belongs to the above popup */
			SetupLabType,	/* label widgets */
			SetupLabExempl,
			SetupLabLayers,
			SetupLabRandom,
			SetupAscType,	/* and the ascii text widgets to enter the values */
			SetupAscExemplar,
			SetupAscLayers,
			SetupAscRandom,
			SetupQuitButton,/* the two command buttons for the setup sub menu to quit or to apply */
			SetupApplyButton, 

			SetupHiddenPopup,/* THE HIDDEN SUB-SUB MENU BELONGS TO THE SETUP-POPUP */
		 	SetupHiddenForm, /* the sub sub menu for hidden layer # */
			*SetupHiddenAsc, /* Ascii Text array to ask nodes in each hidden layer -variable*/
			*SetupHiddenLab, /* ...and their labels	*/
			SetupHiddenQuitButton,
			SetupHiddenApplyButton,
			
			SetupDigAnaPopup,/* THE DIGITAL/ANALOG SUB SUB MENU BELONGS TO THE TOPLEVEL AND MUST BE QUITED BEFORE ANSWERING THE HIDDEN ABOVE */
			SetupDigAnaForm, /* the sub sub menu for Digital/analog matrix use for both max 8 elems */
			SetupDigAna[8],	 /* the ascii text and label boxes array */
			SetupDigAnaQuitButton, /* three buttons */
			SetupDigAnaApplyButton,


/*ONLY IN D TYPE*/	InputPopup,	/* THE INPUT POPUP MENU BELONGS TO THE TOPLEVEL	AND IS USED TO ENTER AN EXAM ARRAY IN DIG OR ANA FORM */
			InputCanvasPopup,/* The canvas popup to draw on it when in digital case, belongs to the TOPLEVEL */

			InputOutputPopup,/* to draw the output, belongs to the toplevel*/
                        InputOutputForm,
			
			InputForm,	 /* the input form for the inputpopup belongs to that and has various control buttons */
			InputCanvasForm, /* belongs to the InputCanvasPopup we draw on it */ 
			InputQuitButton, /* the control buttons */
			InputStartButton,/*Starts up */
			InputAllButton,	 /*sets all red press again all white */
			InputFileButton,
			InputApplyButton,/* svae the pattern */

/*ONLY IN A TYPE */	InputAnalogPopup,/* THE INPUT POPUP FOR ANALOGUE INPUT EXACTLY AS IT WAS FOR D BUT NOW ASKS VALUES*/ 
			InputAnalogForm,
			InputAnalogOutputPopup,
			InputAnalogOutputForm,
			InputAnalogQuitButton,
			InputAnalogNextButton,
			InputAnalogPreviousButton,
			InputAnalogApplyButton,
			InputAnalogFileButton,
			InputAnalogAscBox,
			*InputAnalogAscOutput,
			InputAnalogAscPointer,/* the analog input */

			InputFilePopup,
			InputFileForm,
			InputFileNameAscBox,
			InputFileLoadButton,
			InputFileStepButton,
			InputFileAllButton,
			InputFileQuitButton,

/* ONLY IN D TYPE*/	TrainingPopup,  /* THE TRAINING POPUP BELONGS TO TE TOPLEVEL MANY EXEMPLARS */
			TrainingForm,	/* the form of the control panel of the popup belongs to the popup above */
			TrainingInpCanvasPopup, /* there are two areas to draw on: the input and tha ouput canvas*/
			TrainingOutCanvasPopup,
			TrainingInpCanvasForm,
			TrainingOutCanvasForm, 
			TrainingQuitButton, /* the control buttons */
			TrainingStartButton,
			TrainingAllInputButton,
			TrainingAllOutputButton,
			TrainingApplyButton,
			TrainingApplySingleButton, /* this saves single patterns */
			TrainingNextExemplarButton,
			TrainingPreviousExemplarButton,
			TrainingAscExemplar, /* label to tell us which exemplar is on */

/*ONLY IN A TYPE*/	TrainingAnalogPopup, /*THE SAME AS THE ABOVE POPUP BUT FOR THE A TYPE ASKS VALUES */
			TrainingAnalogForm,
			TrainingAnalogQuitButton,
			TrainingAnalogNextInputNodeButton,/* next node for input and output*/
			TrainingAnalogNextOutputNodeButton,
			TrainingAnalogNextExemplarButton, /* next -previous exemplars*/
			TrainingAnalogPreviousExemplarButton,
			TrainingAnalogApplyButton,
			TrainingAnalogAscExemplar, /*RO */
			TrainingAnalogInputAscBox,
			TrainingAnalogInputAscLab,
			TrainingAnalogOutputAscBox,
			TrainingAnalogOutputAscLab, 
		        TrainingAnalogAscInputNode, /*RO */
		        TrainingAnalogAscOutputNode, /*RO */


                        RunningPopup, /* the popup for running routine */
                        RunningForm,

                        RunningErrorCanvasPopup,
                        RunningErrorCanvasForm,

                        RunningRateCanvasPopup,
                        RunningRateCanvasForm,

                        RunningStartButton,
                        RunningQuitButton,
                        RunningCreateButton,
                        RunningRandomButton,
                        RunningXButton,

			RunningItersAscLab,
                        RunningRateLabel,
                        RunningNodeLabel,
                        RunningErrorLabel,
                        *RunningNodeAscLab,
                        *RunningRateAscBox,  /*RO*/
                        *RunningErrorAscBox, /*RO*/


                        FileopsPopup,
                        FileopsForm,
        
                        FileopsQuitButton,
                        FileopsSaveParamsButton,
                        FileopsLoadParamsButton,
                        FileopsSaveTrainingButton,
                        FileopsLoadTrainingButton,
                        FileopsConvertButton,
                        
                        FileopsNameBox,

			ConversionsPopup,
			ConversionsForm,
			ConversionsQuitButton,
			ConversionsApplyButton,
			ConversionsInputNameBox,  /*RO */
			ConversionsInputNameAscBox,			
			ConversionsOutputNameBox,  /*RO */
			ConversionsOutputNameAscBox,
			*ConversionsTargetBox, /*RO*/
			*ConversionsTargetAscBox,
			ConversionsNormaliseAscBox,
			ConversionsNormaliseBox,

			DisplayTrainButton, 
			DisplaySaveButton,
         		DisplayLabFilename,
	    		DisplayLoadButton,
	       		DisplayAscFilename, 
	          	DisplayForm,
		     	DisplayQuitButton, 
			DisplayRunButton,
			DisplayAscDataname, 
			DisplayButton, 
			DisplayPopup,		
			DisplayLabDataname,


                        ParametersPopup,
                        ParametersForm,
                        ParametersQuitButton,
                        ParametersApplyButton,

			ParametersAscBeta,
			ParametersLabBeta,
			ParametersAscLamda,
			ParametersLabLamda,
                        ErrorPopup,
                        ErrorForm,

                        Rheostat,
                        RheostatValueBox;

/* FINISH THE WIDGETS */
		        
char			Type[3], /* ie digital or analogoue input of the ANN */
			Hidden[30][5], /* maximum 30 hidden layers or use pointer */
			beta[30] , lamda[30],
			Exemplars[5], Layers[5],
			InpNodes[5], OutNodes[5], /* this should change some time to be compatible with the neural proc*/	
			InpHei[5], InpWid[5],
			OutHei[5], OutWid[5]; /* if digital type then input and output expressed as HxW*/

Window			win0, win1;

int			inphei, inpwid,
			outhei, outwid,
			image_height, image_width,			
			AllFlag, /* flags used for the red white all paint */
			AllInpFlag,
			AllOutFlag,
			Network_Not_Mapped,
			AnalogNodePointer, /* pointers to show	 current node and exemplar */
			AnalogNodePointerInput,
			AnalogNodePointerOutput,
			ExemplarPointer;
				 
BYTE			*orig;
BYTE			orig1[116000];

/* some housekeeping routines */
void			Initialize(void);
void			PutColorMap( void );
void 			XInitialize( int *argcptr, char **argv );
void			CalculateStructSizes( void );



/* create widgets and popups for all the main window buttons and theis contents*/
void			CreateButtonsOfControlPanel(void);
void			CreateTheSetupDialogBox(void);
void			CreateTheInputDialogBox(void);
void			CreateTheTrainingDialogBox(void);
void			CreateTheRunningDialogBox(void);
void			CreateTheFileopsDialogBox(void);
void			CreateTheConversionsDialogSubBox(void);
void			CreateTheErrorHandlerDialogBox(void);
void                    CreateTheAboutDialogBox(void);
void			CreateTheParametersDialogBox(void);

/* event handlers for redrawing screen */ 
void			DrawTheNeuralNetwok( void );
void			TopLevelExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			InputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			TrainingInputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			TrainingOutputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			RunningInterruptEventHandler( Widget w, caddr_t unused, register XEvent *event);



/* event handlers for mouse position for digital boxes */
void			InputWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void			TrainingInpWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void			TrainingOutWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );

/* various event handlers */
void            	ErrorPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void            	AboutPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );


/* Callback routines for main window buttons */
void			SetupPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			AboutRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			RunningPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			QuitRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the control panel call back routines */
void			ParametersPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );

/* Callback routines for Setup popup */
void			SetupApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the setup sub sub menu call backs*/
void			SetupPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the routine that will pop DOWN the setup sub sub menu */

void			SetupHiddenDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupHiddenApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupHiddenPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			SetupDigAnaDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupDigAnaApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupDigAnalPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );

/* Callback routines for Parameters Popup */
void                    ParametersPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void                    ParametersQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void                    ParametersApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );


/* Callback routines for Input popup */
void			InputPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputAllRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			InputAnalogNextRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputAnalogPreviousRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputFilePopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputFileQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputFileAllRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputFileStepRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputFileLoadRoutine( Widget W, XtPointer client_data, XtPointer call_data );


/* Callback routines for Training popup Digital and analog type*/ 
void			TrainingPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAllInputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAllOutputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingApplySingleRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			TrainingAnalogNextInputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogNextOutputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/*callback routines for Running popup */
void	            	RunningStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void	            	RunningClearWindowRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void	            	RunningPopdownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	SetRandomValuesInNetwork( Widget W, XtPointer client_data, XtPointer call_data );
void			PutNoiseInNetwork( Widget W, XtPointer client_data, XtPointer call_data );

/*callbackroutines for fileops popup */
void            	FileopsQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	FileopsSaveParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsLoadParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	FileopsSaveTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsLoadTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );
/*call back routine for cantata popup*/
void			ConversionsPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			ConversionsByte2FloatRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			ConversionsPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );

/* for the error handler display message */
void			DisplayError( char *str );

void		GetRheostatValue(Widget w, XtPointer closure, XtPointer call_data);


/* thats all for XXXXXXXXXXXXXX */

/* TRANSPUTER EXTERNAL DECLARATIONS */
/* VARIABLES */

int     DEBUG,
	RANDOM;

Neuron  **NCP;
int     max_layers, max_layers_OLD,
	*CFTable,
	num_exemplars, num_exemplars_OLD, /* the number of training vectors */
	max_iters,
	vectors[100],
	*RNDArray,
	RandomPointer,
	iterations,
	*RandomVectorsArray,
	RequestedInterrupt;


struct  A_SIZE  	Sizes;

	
double  Beta, Lamda,           /* the rate of learning as defined in the hebbian rule */
	*examination,
	*single_output,
	OldError,
        OldRate,
	NormError,
        NormRate,
	step,
	*DigitalTempExaminationData,
	*AnalogTempExaminationData,
	***SuperErrorMatrix,
	SuperError,
	*desired;

					
struct TRAINING	   	*Training,
		   	*AnalogTempTrainingData,
		   	*DigitalTempTrainingData;

/* FLAGS */
int     First_time_setup_flag,
        CFT_has_changed_flag,
	ReplaceWeightsFlag;
        
/* 	ehandler.c	*/
int     ErrorHandler( unsigned function_code, int description, unsigned useful_number );
void 	Quit( int exit_code );
void 	FreeNeuronData( Neuron n );



Neuron	CreateNeuron( int layer, int node, int inpnum, int outnum );

void	ForwardPropagate( int exemplar );
void	BackPropagate( int exemplar );
void	CalculateNewWeights( void );
void    ErrorStatistics( int exemplar );
double	Random( double max );
void    FillRandomArray( void );
void    SparcInitialize( void );
void    FeedInputs( int exemplar );
double  f( double input, double threshold );
void	PutNoise( void );
void	CreateTheNeuralNetwork( void ); 
void	DisplayError( char *str );
void	UpdateSuperErrorMatrix( void );

/* MAIN X PORTING ROUTINES	*/

main( int argc, char **argv )
{
	SparcInitialize();
	Initialize();
	XInitialize(&argc, argv); /* open our window */

    	XtAppMainLoop(app); /* wait for Button events */

}


