        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "SMain.h"

#define	INP_FLAG	O_RDONLY	/* it uses open */
#define	OUT_FLAG	0644		/* it uses creat */
#define	NORMALISE_VALUE	255.0
#define	CF		3
#define	OUTPUT		1.0
#define	CANTATA_TEMP_FILE	"/usr/tmp/temp"

void	ConversionsPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg     arg[10];
	String	string;
	int     i, out;
	char	dummy[100], label[40];
	

	out = CFTable[max_layers-1];
	
	if( (ConversionsTargetBox=(Widget *)calloc(out, sizeof(Widget))) == NULL )
		ErrorHandler(90, MALLOC_ERROR, 0);
	if( (ConversionsTargetAscBox=(Widget *)calloc(out, sizeof(Widget))) == NULL )
		ErrorHandler(90, MALLOC_ERROR, 1);
	
	for(i=0;i<out;i++){
		sprintf(label, "Target O/P: %d", i);
		ConversionsTargetBox[i]     = XtVaCreateManagedWidget(label, labelWidgetClass, ConversionsForm, NULL);
		ConversionsTargetAscBox[i]  = XtVaCreateManagedWidget(label, asciiTextWidgetClass, ConversionsForm, XtNeditType, XawtextEdit, NULL );
	}
                
	i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )/*205*/250 );i++;
        XtSetArg(arg[i], XtNheight, (Dimension )(22*out+100) );i++;
        XtSetArg(arg[i], XtNx, (Position )300);i++;
        XtSetArg(arg[i], XtNy, (Position )50);i++;
        XtSetValues( ConversionsPopup, arg, i );


        XtSetArg(arg[0], XtNstring, &string);
        XtGetValues(FileopsNameBox, arg, 1);
        strcpy(dummy, string);

        if( dummy[0] != NULL ) XtVaSetValues(ConversionsInputNameAscBox, XtNstring, dummy, NULL); 
        sprintf(label, "%f", NORMALISE_VALUE );
        XtVaSetValues(ConversionsNormaliseAscBox, XtNstring, label, NULL);


        XtPopupSpringLoaded( ConversionsPopup );

}

void	ConversionsByte2FloatRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	FILE	*fin,
		*fout;
	Arg	arg[2];
	String	string;
	int	in = NULL,
		out= NULL;
	char	input[100],
		dummy[100],
		output[130],
		ascii_buffer[SAFE_LINE];
	u_char	buffer[50] ;
	int	bytes = 0,
		bytes_read = 0,
		index = 1, i,
		Error = FALSE,
		lines = 1;
	float	normalise_value,
		*target_value;

	if( (target_value=(float *)calloc(CFTable[max_layers-1], sizeof(float))) == NULL )
		ErrorHandler(88, MALLOC_ERROR, 0);
		
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(ConversionsInputNameAscBox, arg, 1);
 	strcpy(input, string);

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(ConversionsOutputNameAscBox, arg, 1);
	strcpy(output, string);

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(ConversionsNormaliseAscBox, arg, 1);
	if( (normalise_value=atof(string)) <= 0 ) normalise_value = 255.0;

	for(i=0;i<CFTable[max_layers-1];i++){
		XtSetArg(arg[0], XtNstring, &string);
		XtGetValues(ConversionsTargetAscBox[i], arg, 1);
		if( !strcmp(string, "") ) {
			target_value = NULL;
			DisplayError(" Will convert data to be used as TESTING vector ");
			break;
		}
		target_value[i] = atof(string);  
	}

	if( target_value != NULL ) DisplayError(" Will convert data to be used as TRAINING  vector ");
	               
	if( (in=open(input, INP_FLAG)) <= 0 ){
		ErrorHandler(88, FILE_OPEN_ERROR, 0);
	       	if( target_value != NULL ) free( target_value );
		return;
	}
        if( (out=creat(CANTATA_TEMP_FILE, OUT_FLAG)) <= 0 ){
        	ErrorHandler(88, FILE_OPEN_ERROR, 1);
		close(in);
	       	if( target_value != NULL ) free( target_value );
		return;
	}

	while( TRUE ){
		if( (bytes_read=read(in, buffer, 1)) <= 0 ){
			if( bytes_read < 0 ){
				ErrorHandler(88, FILE_READ_ERROR, 0);
				Error = TRUE;
			}
			break;		
		} /* if can't read input file */
		sprintf(buffer, "%f ", ((float )buffer[0]) / normalise_value);

		if( !write(out, buffer, strlen(buffer)) ){
			ErrorHandler(88, FILE_WRITE_ERROR, 0);
			Error = TRUE;
			break;
		} /* if cannot write data */

		if( !(index%CFTable[0]) ) { /* end of one exemplar: write the target iff this is training and not test vector */
			if( target_value != NULL ){
				strcpy(buffer, "	");
				if( !write(out, buffer, strlen(buffer)) ){
					ErrorHandler(88, FILE_WRITE_ERROR, 1);
					Error = TRUE;
					break;
				} /* if cannot write */
				for(i=0;i<CFTable[max_layers-1];i++){
					sprintf(buffer, " %f", target_value[i]);
					if( !write(out, buffer, strlen(buffer)) ){
						ErrorHandler(88, FILE_WRITE_ERROR, 2);
						Error = TRUE;
						break;
						}
				} /* for all target values */
			} /* if this vector is training  ie TD = NULL */
			strcpy(buffer, "\n"); /* add a newline */
			if( !write(out, buffer, strlen(buffer)) ){
				ErrorHandler(88, FILE_WRITE_ERROR, 3);
				Error = TRUE;
				break;
			} /* if can't write newline */
			if( ++lines > num_exemplars )	break;
		} /* if we have finished a line of data (1 exemplar that is ) */
		index++;		
	} /* while true */

	
	close(in);
	close(out);

	if( Error ) {
        	if( target_value != NULL ) free( target_value );
		return;
	}
	
	lines--;

	
	if( (fin=fopen(CANTATA_TEMP_FILE, "r")) <= 0 ){
		ErrorHandler(88, FILE_OPEN_ERROR, 0);
        	if( target_value != NULL ) free( target_value );
		return;
	}
        if( (fout=fopen(output, "w")) <= 0 ){
        	ErrorHandler(88, FILE_OPEN_ERROR, 1);
        	if( target_value != NULL ) free( target_value );
		close(in);
		return;
	}


	if( target_value != NULL )	fprintf(fout, "%%%d\n", lines); /* the numebr of exemplars iff TRAINING */
	if( lines < num_exemplars ){
		ErrorHandler(88, UNEXPECTED_EOF_MODIFY, lines);
		Error = TRUE;
	} /* just in case */
	
	if( !Error ){
		for(i=0;i<lines;i++){
			if( feof(fin) ) {
				ErrorHandler(88, UNEXPECTED_EOF_MODIFY, 1);
				Error = TRUE;
				break;
			}
			fgets(ascii_buffer, SAFE_LINE, fin);
			fputs(ascii_buffer, fout);
		}	
	}
	fclose(fout);
	fclose(fin);
       	if( target_value != NULL ) free( target_value );

	unlink(CANTATA_TEMP_FILE);

	if( Error ) return;
	
        XtSetArg(arg[0], XtNstring, &string);
       	XtGetValues(ConversionsOutputNameAscBox, arg, 1);
       	strcpy(dummy, string);
        XtVaSetValues(FileopsNameBox, XtNstring, dummy, NULL);

	
}
			        

void	ConversionsPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int 	i;
	
	for(i=0;i<CFTable[max_layers-1];i++){
		XtDestroyWidget(ConversionsTargetBox[i]);
		XtDestroyWidget(ConversionsTargetAscBox[i]);
	}

	free(ConversionsTargetAscBox);
	free(ConversionsTargetBox);
	
        XtPopdown( ConversionsPopup );
}

        
