        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "SMain.h"
#include "XMain.h"

void	ErrorStatistics( int exemplar )
/* Will calculate total error for a training exemplar and rate of change 
   with previous error */
{
	char	label[30];
	double	TotalError = 0.0,
		TotalRate  = 0.0;
	int 	node, PlotError, PlotRate;
	int	pr_node, cu_node, lay;
	
	for(node=0;node<CFTable[max_layers-1];node++){
		TotalError +=  	(Training[exemplar].Target[node] - (NCP[max_layers-1][node])->output) *
				(Training[exemplar].Target[node] - (NCP[max_layers-1][node])->output);
		printf("SUB=%lf, PW=%lf\n",ABS(Training[exemplar].Target[node] - (NCP[max_layers-1][node])->output), pow( ABS(Training[exemplar].Target[node] - (NCP[max_layers-1][node])->output), 2));
	} 
	TotalError /= (double )CFTable[max_layers-1]; /* mean square error */


	sprintf(label, "%d", max_iters-iterations);
	XtVaSetValues(RunningItersAscLab, XtNstring, label, NULL);
/*	if( iterations % 5 == 0 ) printf("TE = %4.2lf,  TR=%4.2lf at ITER = %d\n", TotalError, TotalRate, iterations);*/
/* 	we write results on window in Learning() function */
	
	if( iterations < 3 ){		
		TotalRate = (TotalError - OldError) / step; /* Dy/Dx */
		OldError  = TotalError;
		OldRate   = TotalRate;
		NormError = ABS( TotalError + 0.2*TotalError );
		NormRate  = ABS( TotalRate + 0.2*TotalRate );
	} else {
		PlotError = ERROR_BOX_Y - 
			    (int )(TotalError * ERROR_BOX_Y / NormError);
		PlotRate  = (int )(ERROR_BOX_Y / 2) - 
			    (int )(TotalRate * ERROR_BOX_Y / (2*NormRate));
	
		XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), redgc,
				step * (iterations -1),
				ERROR_BOX_Y - (int )(ERROR_BOX_Y * (OldError / NormError)),
				step * iterations, 
				ERROR_BOX_Y - (int )(ERROR_BOX_Y *(TotalError / NormError)) );
		XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), bluegc,
				step * (iterations -1),
				-(int )((ERROR_BOX_Y/2) * (OldRate / NormRate)) + (int )(ERROR_BOX_Y/2),
				step * iterations,
				-(int )((ERROR_BOX_Y/2) * (TotalRate / NormRate)) + (int )(ERROR_BOX_Y/2) );
		XFlush( dpy );
		OldError = TotalError;
/*
		if( TotalError < MinError ){
			for(lay=1;lay<max_layers;lay++)
				for(cu_node=0;cu_node<CFTable[lay];cu_node++)
					for(pr_node=0;pr_node<CFTable[lay-1];pr_node++)
					MinWeights[lay][cu_node][pr_node] =
						(NCP[lay][cu_node])->weight[pr_node];
			MinError = TotalError;
		}
		*/
		TotalError = 0.0;
		OldRate  = TotalRate;

	}
}


