        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "XMain.h"
#include "SMain.h"


void	CreateButtonsOfControlPanel( void )
{

	/* the 	buttons inside the window belonging to the toplevel */
	AboutButton 	= XtVaCreateManagedWidget("AboutButton", commandWidgetClass, Wpar, NULL);
	SetupButton 	= XtVaCreateManagedWidget("SetupButton", commandWidgetClass, Wpar, NULL);
	ParametersButton= XtVaCreateManagedWidget("ParametersButton", commandWidgetClass, Wpar, NULL);
	TrainingButton 	= XtVaCreateManagedWidget("TrainingButton", commandWidgetClass, Wpar, NULL);
	RunningButton 	= XtVaCreateManagedWidget("RunningButton", commandWidgetClass, Wpar, NULL);
	InputButton	= XtVaCreateManagedWidget("InputButton", commandWidgetClass, Wpar, NULL);
	SaveButton 	= XtVaCreateManagedWidget("SaveButton", commandWidgetClass, Wpar, NULL);
	QuitButton 	= XtVaCreateManagedWidget("QuitButton", commandWidgetClass, Wpar, NULL);
	DisplayButton 	= XtVaCreateManagedWidget("DisplayButton", commandWidgetClass, Wpar, NULL);


	/* and the callbacks for the buttons inside the control panel */

	XtAddCallback(AboutButton, XtNcallback, AboutRoutine, 0);
	XtAddCallback(SetupButton, XtNcallback, SetupPopUpRoutine, 0);
	XtAddCallback(ParametersButton, XtNcallback, ParametersPopupRoutine, 0);
	XtAddCallback(InputButton, XtNcallback, InputPopUpRoutine, 0);
	XtAddCallback(TrainingButton, XtNcallback, TrainingPopupRoutine, 0);
	XtAddCallback(RunningButton, XtNcallback, RunningPopupRoutine, 0);
	XtAddCallback(SaveButton, XtNcallback, FileopsPopupRoutine, 0);
   	XtAddCallback(QuitButton,  XtNcallback,  QuitRoutine,  0);
   	XtAddCallback(DisplayButton,  XtNcallback,  DisplayPopupRoutine,  0);
	
 }

void	CreateTheTrainingDialogBox( void )
{
/* where no name is digital */
	TrainingPopup	= XtVaCreatePopupShell("Digital Type Training", transientShellWidgetClass, toplevel,NULL);
	TrainingInpCanvasPopup= XtVaCreatePopupShell("Input Training Pattern", transientShellWidgetClass, TrainingPopup,NULL);
	TrainingOutCanvasPopup= XtVaCreatePopupShell("Output Training Pattern", transientShellWidgetClass, TrainingPopup,NULL);

	TrainingForm	= XtVaCreateManagedWidget( "Digital Training Form", boxWidgetClass, TrainingPopup, NULL);
	TrainingInpCanvasForm	= XtVaCreateManagedWidget( "canvas Inp", boxWidgetClass, TrainingInpCanvasPopup, NULL);/*  to draw input */
	TrainingOutCanvasForm	= XtVaCreateManagedWidget( "canv Out", boxWidgetClass, TrainingOutCanvasPopup, NULL);/*  to draw output*/
	
	/* We also need a quit button a reset button and an apply  button (command) */
	TrainingStartButton= XtVaCreateManagedWidget("   Start     ",commandWidgetClass,TrainingForm,NULL);
	TrainingAllInputButton  = XtVaCreateManagedWidget("   All Inp   ",commandWidgetClass,TrainingForm,NULL);
	TrainingAllOutputButton  = XtVaCreateManagedWidget("   All Out   ",commandWidgetClass,TrainingForm,NULL);
	TrainingNextExemplarButton= XtVaCreateManagedWidget("   Next Exe  ",commandWidgetClass,TrainingForm,NULL);
	TrainingPreviousExemplarButton= XtVaCreateManagedWidget("   Pre Exe   ",commandWidgetClass,TrainingForm,NULL);
	TrainingApplySingleButton= XtVaCreateManagedWidget(" Apply Single",commandWidgetClass,TrainingForm,NULL);
	TrainingApplyButton= XtVaCreateManagedWidget(" Apply All   ",commandWidgetClass,TrainingForm,NULL);
	TrainingQuitButton	= XtVaCreateManagedWidget("    Quit     ",commandWidgetClass,TrainingForm,NULL);

/*RO*/	TrainingAscExemplar= XtVaCreateManagedWidget("dig exem",asciiTextWidgetClass,TrainingForm,NULL);
	
	/* and their call backs */
	XtAddCallback(TrainingQuitButton,XtNcallback, TrainingPopDownRoutine,NULL);
	XtAddCallback(TrainingStartButton,XtNcallback, TrainingStartRoutine, NULL);
	XtAddCallback(TrainingAllInputButton,XtNcallback, TrainingAllInputRoutine, NULL);
	XtAddCallback(TrainingAllOutputButton,XtNcallback, TrainingAllOutputRoutine, NULL);
	XtAddCallback(TrainingApplyButton,XtNcallback, TrainingApplyRoutine, NULL);
	XtAddCallback(TrainingApplySingleButton,XtNcallback, TrainingApplySingleRoutine, NULL);
	XtAddCallback(TrainingNextExemplarButton,XtNcallback, TrainingNextExemplarRoutine, NULL);
	XtAddCallback(TrainingPreviousExemplarButton,XtNcallback, TrainingPreviousExemplarRoutine, NULL);

/* now the analogue type */
	TrainingAnalogPopup= XtVaCreatePopupShell("Analogue Type Training", transientShellWidgetClass, toplevel,NULL);
	TrainingAnalogForm	= XtVaCreateManagedWidget( "Analog box", boxWidgetClass, TrainingAnalogPopup, NULL);

	/* the buttons */
	TrainingAnalogQuitButton = XtVaCreateManagedWidget(" Quit ",commandWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogNextInputNodeButton = XtVaCreateManagedWidget("Next Inp ",commandWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogNextExemplarButton = XtVaCreateManagedWidget(" Next Exe",commandWidgetClass,TrainingAnalogForm,NULL);
	
	TrainingAnalogApplyButton = XtVaCreateManagedWidget("Apply ",commandWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogNextOutputNodeButton = XtVaCreateManagedWidget("Next Out ",commandWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogPreviousExemplarButton = XtVaCreateManagedWidget(" Pre Exe ",commandWidgetClass,TrainingAnalogForm,NULL);


	/* one AsciiText widget  the value and the node # */
/*RO*/	TrainingAnalogInputAscLab  = XtVaCreateManagedWidget("Input  Value ",labelWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogInputAscBox  = XtVaCreateManagedWidget("Analog box Inp",asciiTextWidgetClass,TrainingAnalogForm,XtNeditType, XawtextEdit,NULL);

/*RO*/	TrainingAnalogOutputAscLab = XtVaCreateManagedWidget("Output Value ",labelWidgetClass,TrainingAnalogForm,NULL);
	TrainingAnalogOutputAscBox = XtVaCreateManagedWidget("Analog box Out",asciiTextWidgetClass,TrainingAnalogForm,XtNeditType, XawtextEdit,NULL);
/*RO*/	TrainingAnalogAscInputNode = XtVaCreateManagedWidget("Analog node Inp",asciiTextWidgetClass,TrainingAnalogForm,NULL);
/*RO*/	TrainingAnalogAscOutputNode= XtVaCreateManagedWidget("Analog node Out",asciiTextWidgetClass,TrainingAnalogForm,NULL);
/*RO*/	TrainingAnalogAscExemplar  = XtVaCreateManagedWidget("Analog exem",asciiTextWidgetClass,TrainingAnalogForm,NULL);

	/* and their callbacks */
	XtAddCallback(TrainingAnalogQuitButton,XtNcallback, TrainingPopDownRoutine,NULL);
	XtAddCallback(TrainingAnalogNextInputNodeButton,XtNcallback, TrainingAnalogNextInputNodeRoutine,NULL);
	XtAddCallback(TrainingAnalogNextOutputNodeButton,XtNcallback, TrainingAnalogNextOutputNodeRoutine,NULL);
	XtAddCallback(TrainingAnalogNextExemplarButton,XtNcallback, TrainingAnalogNextExemplarRoutine,NULL);
	XtAddCallback(TrainingAnalogPreviousExemplarButton,XtNcallback, TrainingAnalogPreviousExemplarRoutine,NULL);
	XtAddCallback(TrainingAnalogApplyButton,XtNcallback, TrainingApplyRoutine,NULL); /* some of them have the same routines as the digital coz type checked*/
	

}

void	CreateTheInputDialogBox( void )
{
/* where no name is digital */
	InputPopup	= XtVaCreatePopupShell("Discrete Type Input", transientShellWidgetClass, toplevel,NULL);
	InputCanvasPopup= XtVaCreatePopupShell("Input Pattern", transientShellWidgetClass, InputPopup,NULL);
	InputOutputPopup= XtVaCreatePopupShell( "Digital IO Popup", transientShellWidgetClass, InputPopup, NULL);
InputAnalogOutputPopup  = XtVaCreatePopupShell( "ANALO IO Popup", transientShellWidgetClass, InputPopup, NULL);
	InputFilePopup  = XtVaCreatePopupShell( "FILE INPUT", transientShellWidgetClass, InputPopup, NULL);

	InputForm	= XtVaCreateManagedWidget( "Digital Input Form", boxWidgetClass, InputPopup, NULL);
	InputCanvasForm	= XtVaCreateManagedWidget( "canvas", boxWidgetClass, InputCanvasPopup, NULL);/*  to draw*/
	InputOutputForm = XtVaCreateManagedWidget( "IO F", boxWidgetClass, InputOutputPopup, NULL);/*  to draw*/
InputAnalogOutputForm   = XtVaCreateManagedWidget( "ANA IO F", boxWidgetClass, InputAnalogOutputPopup, NULL);
	InputFileForm   = XtVaCreateManagedWidget( " F", boxWidgetClass, InputFilePopup, NULL);/*  to draw*/

	/* We also need a quit button a reset button and an apply button (command) */
	InputQuitButton	= XtVaCreateManagedWidget("  Quit   ",commandWidgetClass,InputForm,NULL);
	InputStartButton= XtVaCreateManagedWidget("  Start  ",commandWidgetClass,InputForm,NULL);
	InputAllButton  = XtVaCreateManagedWidget(" All One ",commandWidgetClass,InputForm,NULL);
	InputApplyButton= XtVaCreateManagedWidget("  Apply  ",commandWidgetClass,InputForm,NULL);
	InputFileButton = XtVaCreateManagedWidget("  File   ",commandWidgetClass,InputForm,NULL);

	/* and their call backs */
	XtAddCallback(InputQuitButton,XtNcallback, InputPopDownRoutine,NULL);
	XtAddCallback(InputStartButton,XtNcallback, InputStartRoutine, NULL);
	XtAddCallback(InputAllButton,XtNcallback, InputAllRoutine, NULL);
	XtAddCallback(InputApplyButton,XtNcallback, InputApplyRoutine, NULL);
	XtAddCallback(InputFileButton,XtNcallback, InputFilePopUpRoutine, NULL);
	

/* now the analogue type */
	InputAnalogPopup= XtVaCreatePopupShell("Analogue Type Input", transientShellWidgetClass, toplevel,NULL);
	InputAnalogForm	= XtVaCreateManagedWidget( "Analog box", boxWidgetClass, InputAnalogPopup, NULL);

	/* the buttons */
	InputAnalogNextButton = XtVaCreateManagedWidget("    Next     ",commandWidgetClass,InputAnalogForm,NULL);
	InputAnalogPreviousButton = XtVaCreateManagedWidget("  Previous   ",commandWidgetClass,InputAnalogForm,NULL);
	InputAnalogApplyButton = XtVaCreateManagedWidget("    Apply    ",commandWidgetClass,InputAnalogForm,NULL);
	InputAnalogQuitButton = XtVaCreateManagedWidget("     Quit    ",commandWidgetClass,InputAnalogForm,NULL);
	InputAnalogFileButton = XtVaCreateManagedWidget("  File   ",commandWidgetClass,InputAnalogForm,NULL);
	/* one AsciiText widget  the value and the node #*/
/*RO*/	InputAnalogAscPointer	= XtVaCreateManagedWidget("Analog point",asciiTextWidgetClass,InputAnalogForm,NULL);
	InputAnalogAscBox 	= XtVaCreateManagedWidget("Analog box",asciiTextWidgetClass,InputAnalogForm,XtNeditType, XawtextEdit,NULL);

	/* and their callbacks */
	XtAddCallback(InputAnalogQuitButton,XtNcallback, InputPopDownRoutine,NULL);
	XtAddCallback(InputAnalogNextButton,XtNcallback, InputAnalogNextRoutine,NULL);
	XtAddCallback(InputAnalogPreviousButton,XtNcallback, InputAnalogPreviousRoutine,NULL);
	XtAddCallback(InputAnalogApplyButton,XtNcallback, InputApplyRoutine,NULL); /* some of them have the same routines as the digital coz type checked*/
	XtAddCallback(InputAnalogFileButton,XtNcallback, InputFilePopUpRoutine,NULL); /* some of them have the same routines as the digital coz type checked*/



/* also the FilePopup */

	InputFileNameAscBox = XtVaCreateManagedWidget("Filename",asciiTextWidgetClass,InputFileForm,XtNeditType, XawtextEdit,NULL);
	InputFileLoadButton = XtVaCreateManagedWidget("    Load File    ",commandWidgetClass,InputFileForm,NULL);
	InputFileStepButton = XtVaCreateManagedWidget("Read single line ",commandWidgetClass,InputFileForm,NULL);
	InputFileAllButton  = XtVaCreateManagedWidget(" Read all lines  ",commandWidgetClass,InputFileForm,NULL);	
	InputFileQuitButton = XtVaCreateManagedWidget("       Quit      ",commandWidgetClass,InputFileForm,NULL);	

	XtAddCallback(InputFileQuitButton,XtNcallback, InputFileQuitRoutine,NULL);
	XtAddCallback(InputFileAllButton,XtNcallback, InputFileAllRoutine,NULL);
	XtAddCallback(InputFileStepButton,XtNcallback, InputFileStepRoutine,NULL);
	XtAddCallback(InputFileLoadButton,XtNcallback, InputFileLoadRoutine,NULL);

}


void 	CreateTheSetupDialogBox( void )
{
	/* The Parent of the SetupDialogBox  Belonging to the toplevel */
	SetupPopup	= XtVaCreatePopupShell("ANN SETUP", transientShellWidgetClass, toplevel,NULL);
	SetupForm	= XtVaCreateManagedWidget( "SetupForm",boxWidgetClass, SetupPopup, NULL);

	/* The Labels belonging to the SetupForm, We label the data in them */
	SetupLabType	= XtVaCreateManagedWidget("Type (D/C)",labelWidgetClass,SetupForm,NULL);
	SetupAscType	= XtVaCreateManagedWidget("DigiAna",asciiTextWidgetClass,SetupForm,XtNeditType, XawtextEdit,NULL);

	SetupLabRandom	= XtVaCreateManagedWidget("RND (Y/N) ",labelWidgetClass,SetupForm,NULL);
	SetupAscRandom  = XtVaCreateManagedWidget("SetupAscRND",asciiTextWidgetClass,SetupForm,XtNeditType, XawtextEdit,NULL);

 	SetupLabExempl	= XtVaCreateManagedWidget("Exemplars ",labelWidgetClass,SetupForm,NULL);
	SetupAscExemplar= XtVaCreateManagedWidget("SetupAscExemplar",asciiTextWidgetClass,SetupForm,XtNeditType, XawtextEdit,NULL);

	SetupLabLayers	= XtVaCreateManagedWidget("  Layers  ",labelWidgetClass,SetupForm,NULL);
	SetupAscLayers	= XtVaCreateManagedWidget("SetupAscLayers",asciiTextWidgetClass,SetupForm, XtNeditType, XawtextEdit,NULL);

	/* The Ascii Boxes belonging to the SetupForm, We get the data from them */

	/* We also need a quit button and an apply button (command) */
	SetupQuitButton	= XtVaCreateManagedWidget("   Quit   ",commandWidgetClass,SetupForm,NULL);
	SetupApplyButton= XtVaCreateManagedWidget("    Apply    ",commandWidgetClass,SetupForm,NULL);
	/* and their call backs */
	XtAddCallback(SetupQuitButton,XtNcallback,SetupPopDownRoutine,NULL);
	XtAddCallback(SetupApplyButton,XtNcallback,SetupApplyRoutine,NULL);

}	



void	CreateTheRunningDialogBox( void )
{
	RunningPopup =  XtVaCreatePopupShell("RUNNING", transientShellWidgetClass, toplevel,NULL);
	RunningForm  = XtVaCreateManagedWidget( "RunningForm", boxWidgetClass, RunningPopup, NULL);
	
	RunningErrorCanvasPopup = XtVaCreatePopupShell("ERROR", transientShellWidgetClass, RunningPopup,NULL);
	RunningErrorCanvasForm	= XtVaCreateManagedWidget( "canvas Error", boxWidgetClass, RunningErrorCanvasPopup, NULL);
	
/*	RunningRateCanvasPopup  = XtVaCreatePopupShell("RATE", transientShellWidgetClass, RunningPopup,NULL);
	RunningRateCanvasForm	= XtVaCreateManagedWidget( "canv Rate", boxWidgetClass, RunningRateCanvasPopup, NULL);
*/	
	/* We also need a quit button a reset button and an apply button (command) */
	RunningStartButton	= XtVaCreateManagedWidget("   Start     ",commandWidgetClass,RunningForm,NULL);
	RunningQuitButton	= XtVaCreateManagedWidget("    Quit     ",commandWidgetClass,RunningForm,NULL);

	RunningItersAscLab = XtVaCreateManagedWidget("iters", asciiTextWidgetClass, RunningForm, XtNeditType, XawtextEdit,NULL);

	RunningCreateButton	= XtVaCreateManagedWidget("Clear window ",commandWidgetClass,RunningForm,NULL);
	RunningRandomButton	= XtVaCreateManagedWidget("Random Values",commandWidgetClass,RunningForm,NULL);
	RunningXButton		= XtVaCreateManagedWidget("Shake weights",commandWidgetClass,RunningForm,NULL);
	

	/* and their call backs */
	XtAddCallback(RunningStartButton,XtNcallback, RunningStartRoutine, NULL);
	XtAddCallback(RunningQuitButton,XtNcallback, RunningPopdownRoutine, NULL);

	XtAddCallback(RunningCreateButton,XtNcallback, RunningClearWindowRoutine, NULL);
	XtAddCallback(RunningRandomButton,XtNcallback, SetRandomValuesInNetwork, NULL);
	XtAddCallback(RunningXButton,XtNcallback, PutNoiseInNetwork, NULL);


	
	/* we need one label widget for the node number and two asciitext for the value of error and its rate */
	/* these will be created later when press start */

	RunningNodeLabel  =  XtVaCreateManagedWidget( "  OUT NODE   ", labelWidgetClass,RunningForm,NULL);
	RunningErrorLabel =  XtVaCreateManagedWidget( "    ERROR    ", labelWidgetClass,RunningForm,NULL);
	RunningRateLabel  =  XtVaCreateManagedWidget( "RATE OF ERROR", labelWidgetClass,RunningForm,NULL);
	
	/* The rheostat for Beta value */


}



void	CreateTheFileopsDialogBox( void )
{
	FileopsPopup =  XtVaCreatePopupShell("Fileops", transientShellWidgetClass, toplevel,NULL);
	FileopsForm  = XtVaCreateManagedWidget( "FileopsForm", boxWidgetClass, FileopsPopup, NULL);

	FileopsLoadParamsButton = XtVaCreateManagedWidget("Load Params. ",commandWidgetClass,FileopsForm,NULL);
	FileopsSaveParamsButton = XtVaCreateManagedWidget("Save Params. ",commandWidgetClass,FileopsForm,NULL);

	FileopsLoadTrainingButton = XtVaCreateManagedWidget("Load Training",commandWidgetClass,FileopsForm,NULL);
	FileopsSaveTrainingButton = XtVaCreateManagedWidget("Save Training",commandWidgetClass,FileopsForm,NULL);

	FileopsQuitButton = XtVaCreateManagedWidget("    Quit     ",commandWidgetClass,FileopsForm,NULL);

	FileopsConvertButton = XtVaCreateManagedWidget(" Conversions ",commandWidgetClass,FileopsForm,NULL);

	FileopsNameBox	  = XtVaCreateManagedWidget("FName", asciiTextWidgetClass, FileopsForm, XtNeditType, XawtextEdit,NULL);

	XtAddCallback(FileopsQuitButton,XtNcallback, FileopsQuitRoutine, NULL);
        XtAddCallback(FileopsSaveParamsButton,XtNcallback, FileopsSaveParamsRoutine, NULL);
        XtAddCallback(FileopsLoadParamsButton,XtNcallback, FileopsLoadParamsRoutine, NULL);
        XtAddCallback(FileopsSaveTrainingButton,XtNcallback, FileopsSaveTrainingRoutine, NULL);
        XtAddCallback(FileopsLoadTrainingButton,XtNcallback, FileopsLoadTrainingRoutine, NULL);
        XtAddCallback(FileopsConvertButton,XtNcallback, ConversionsPopupRoutine, NULL);
 
}


void	CreateTheErrorHandlerDialogBox( void )
{
	ErrorPopup = XtVaCreatePopupShell("Error", transientShellWidgetClass, toplevel,NULL);
	ErrorForm  = XtVaCreateManagedWidget( "ErrorForm", asciiTextWidgetClass, ErrorPopup, NULL);

}

void    CreateTheParametersDialogBox( void )
{
	ParametersPopup = XtVaCreatePopupShell("Parameters", transientShellWidgetClass, toplevel,NULL);
	ParametersForm	= XtVaCreateManagedWidget("Parameters", boxWidgetClass, ParametersPopup, NULL );

	ParametersLabBeta	= XtVaCreateManagedWidget("   Beta   ",labelWidgetClass,ParametersForm,NULL);
	ParametersAscBeta       = XtVaCreateManagedWidget("SetupAscBeta",asciiTextWidgetClass,ParametersForm,XtNeditType, XawtextEdit,NULL);

	ParametersLabLamda	= XtVaCreateManagedWidget("  Lamda   ",labelWidgetClass,ParametersForm,NULL);
	ParametersAscLamda	= XtVaCreateManagedWidget("SetupAscLamda",asciiTextWidgetClass,ParametersForm,XtNeditType, XawtextEdit,NULL);


/* and the callbacks */
	ParametersApplyButton= XtVaCreateManagedWidget("  Apply   ", commandWidgetClass, ParametersForm, NULL);
	ParametersQuitButton = XtVaCreateManagedWidget("     Quit    ", commandWidgetClass, ParametersForm, NULL);
	
	XtAddCallback(ParametersApplyButton,XtNcallback, ParametersApplyRoutine, NULL);
	XtAddCallback(ParametersQuitButton, XtNcallback, ParametersQuitRoutine, NULL);
	

}		
void	CreateTheAboutDialogBox( void )
{
	AboutPopup = XtVaCreatePopupShell("About", transientShellWidgetClass, toplevel,NULL);
	AboutForm  = XtVaCreateManagedWidget( "AboutForm", asciiTextWidgetClass, AboutPopup, NULL);
}


void	CreateTheConversionsDialogSubBox( void )
{

	ConversionsPopup =  XtVaCreatePopupShell("Conversions", transientShellWidgetClass, toplevel,NULL);
	ConversionsForm  = XtVaCreateManagedWidget( "ConversionsForm", boxWidgetClass, ConversionsPopup, NULL);

	ConversionsApplyButton= XtVaCreateManagedWidget("  Byte2Float ",commandWidgetClass,ConversionsForm,NULL);
	ConversionsQuitButton = XtVaCreateManagedWidget("    Quit     ",commandWidgetClass,ConversionsForm,NULL);

	ConversionsInputNameBox     = XtVaCreateManagedWidget(" Input  file ", labelWidgetClass, ConversionsForm, NULL);
	ConversionsInputNameAscBox  = XtVaCreateManagedWidget("inp name asc", asciiTextWidgetClass, ConversionsForm, XtNeditType, XawtextEdit,NULL);


	ConversionsOutputNameBox    = XtVaCreateManagedWidget(" Output file ", labelWidgetClass, ConversionsForm, NULL);
	ConversionsOutputNameAscBox = XtVaCreateManagedWidget("inp name asc", asciiTextWidgetClass, ConversionsForm, XtNeditType, XawtextEdit,NULL);

	/* the target box is a list of pointers so it is in the popup */

	ConversionsNormaliseBox = XtVaCreateManagedWidget("Normalisation", labelWidgetClass, ConversionsForm, NULL);
	ConversionsNormaliseAscBox  = XtVaCreateManagedWidget("inp name asc", asciiTextWidgetClass, ConversionsForm, XtNeditType, XawtextEdit,NULL);

	XtAddCallback(ConversionsQuitButton,XtNcallback, ConversionsPopDownRoutine, NULL);
        XtAddCallback(ConversionsApplyButton,XtNcallback,  ConversionsByte2FloatRoutine, NULL);
 
}


void	CreateTheDisplayDialogBox( void )
{
	DisplayPopup = XtVaCreatePopupShell("Display", transientShellWidgetClass, toplevel,NULL);
	DisplayForm  = XtVaCreateManagedWidget( "DisplayForm", boxWidgetClass, DisplayPopup, NULL);

	DisplayAscFilename = XtVaCreateManagedWidget("input fname", asciiTextWidgetClass, DisplayForm, XtNeditType, XawtextEdit,NULL);
	DisplayLabFilename = XtVaCreateManagedWidget("Name to Save", labelWidgetClass, DisplayForm, NULL);
	DisplayAscDataname = XtVaCreateManagedWidget("output fname", asciiTextWidgetClass, DisplayForm, XtNeditType, XawtextEdit,NULL);
	DisplayLabDataname = XtVaCreateManagedWidget(" Image name ", labelWidgetClass, DisplayForm, NULL);

	DisplaySaveButton  = XtVaCreateManagedWidget("  Save   ",commandWidgetClass, DisplayForm,NULL);
	DisplayLoadButton  = XtVaCreateManagedWidget("  Load   ",commandWidgetClass, DisplayForm,NULL);
	DisplayQuitButton  = XtVaCreateManagedWidget("  Quit   ",commandWidgetClass, DisplayForm,NULL);
	DisplayTrainButton = XtVaCreateManagedWidget("  Train  ",commandWidgetClass, DisplayForm,NULL);
	DisplayRunButton   = XtVaCreateManagedWidget("   Run   ",commandWidgetClass, DisplayForm,NULL);


	XtAddCallback(DisplaySaveButton,XtNcallback, DisplaySaveRoutine, NULL);
	XtAddCallback(DisplayQuitButton,XtNcallback, DisplayQuitRoutine, NULL);
	XtAddCallback(DisplayRunButton,XtNcallback, DisplayRunningRoutine, NULL);
	XtAddCallback(DisplayLoadButton,XtNcallback, DisplayLoadRoutine, NULL);
	XtAddCallback(DisplayTrainButton,XtNcallback, DisplayTrainingRoutine, NULL);

}
