        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "XMain.h"
#include "SMain.h"


#define M_PI    3.14159265358979323846

void	DrawTheNeuralNetwork( void )
{
	int	Nx_max = 0, Ny_max = 0,
		*Nx, *Ny,
		Dx = 1, Dy = 1,
		Ax, Ay, Bx, By, Cx, Cy,Fx, Fy,
		/*size_y, */down, x, y,
	 	nx_next, ny_next, /*next layer nodes */
	   	x_next, y_next,	 /*next layers joints coords*/
		nx_cur, ny_cur,	 /*current layer nodes */
		x_cur, y_cur,	 /*current layer joints coords */
		i = 0, Break = FALSE, Q_NEG = FALSE,
		/* A TYPE*/
		dist_x, dist_y_cur, dist_y_pre,lay;

	double	q = 0.0;

if( FALSE ){
        XClearWindow(dpy, XtWindow(Wbox));
	Nx = (int *)calloc(max_layers, sizeof(int));
	Ny = (int *)calloc(max_layers, sizeof(int)); /* to store Ns of each layer */

	/* find Nx_max, Ny_max */
	for(i=0;i<max_layers;i++){
		if(i==0){
			Nx[0] = inpwid;
			Ny[0] = inphei;
			Nx_max = MAX(Nx_max, inpwid);
			Ny_max = MAX(Ny_max, inphei);
			continue;
		}
		if(i==max_layers-1){
			Nx[max_layers-1] = outwid;
			Ny[max_layers-1] = outhei;
			Nx_max = MAX(Nx_max, outwid);
			Ny_max = MAX(Ny_max, outhei);
			continue;
		}				
		
		Ny[i] = (int )ceil( sqrt(CFTable[i]) );
		Nx[i] = (int )ceil( (double )CFTable[i] / (double )Ny[i] );

		Nx_max = MAX(Nx_max, Nx[i]);
		Ny_max = MAX(Ny_max, Ny[i]);
	} /*for i=layers */

	/*calculate dx, dy, q-theta */
	
	i = 0;
	while( Break == FALSE )	{
		if(	( (int )( (double )(max_layers*(Dx+20)*Nx_max)*cos(q+M_PI/8) + (double )X_OFF)  <= TOP_LEV_WID ) &&
			( (int )( (double )((Dy+15)*Ny_max) + (double )((Dx+20)*Nx_max)*(double )sin(q+M_PI/8) + (double )Y_OFF) <= TOP_LEV_HEI )	
		) {
		switch( ++i % 3 ){
			case 0: Dy+=15;break;
			case 1: Dx+=20;break;
			case 2: if( Q_NEG == FALSE ) {
					if( sin(q+M_PI/8) < 0.0 || cos(q+M_PI/8) < 0.0 ) Q_NEG = TRUE;
					else q+=M_PI/8;
				} break;
		} /* switch */
		} else Break = TRUE; /*if statement*/
	} /*while break*/
	/* Draw the rectangles */
	/* A	C
	   B	F */
	   
	for(i=0;i<max_layers;i++){
		Ax = (int )( (double )X_OFF + (double )(i*Dx*Nx_max)*cos(q) + 0.5*cos(q)*(double )((Nx_max - Nx[i])*Dx));
		Ay = (int )( (double )Y_OFF + 0.5*(double )(Dy*(Ny_max-Ny[i])) + sin(q)*(double )(Dx*(Nx_max-Nx[i])) );

		Bx = Ax;
		By = Ay + Dy*Ny[i];

		Cx = Ax + (int )((double )(Dx*Nx[i])*cos(q));
		Cy = Ay + (int )((double )(Dx*Nx[i])*sin(q));

		Fx = Cx;
		Fy = Cy + Dy*Ny[i];

		XDrawLine( dpy, XtWindow(Wbox), redgc, Ax, Ay, Bx, By);
		XDrawLine( dpy, XtWindow(Wbox), redgc, Bx, By, Fx, Fy);
		XDrawLine( dpy, XtWindow(Wbox), redgc, Fx, Fy, Cx, Cy);
		XDrawLine( dpy, XtWindow(Wbox), redgc, Cx, Cy, Ax, Ay);

		
		/* Draw the boxes every Dx, Dy */

		for(x=Ax;x<Cx;x+=(int )( (double )(Ax+Cx)/(double )Nx[i] )){
			y = (int )((double )x*sin(q));
			XDrawLine( dpy, XtWindow(Wbox), redgc, x, y, x, y + Ny[i]*Dy );
		} /* vertical */
		
		down = (int )(Nx[i]*Dx*sin(q));
		for(y=Ay;y<Cy;y+=Dy)  /* horizontal */
			XDrawLine( dpy, XtWindow(Wbox), redgc, Ax, y, Cx, y+down );
		
		/* Draw connection lines */
		if(i == max_layers-1) break; 
	
		for(nx_cur=0;nx_cur<Nx[i];nx_cur++)
			for(ny_cur=0;ny_cur<Ny[i];ny_cur++){
				x_cur = nx_cur*Dx + (int )(Dx/2);
				y_cur = ny_cur*Dy + (int )(Dy/2);
				for(nx_next=0;nx_next<Nx[i+1];nx_next++)
					for(ny_next=0;ny_next<Ny[i+1];ny_next++){
						x_next = nx_next*Dx + (int )(Dx/2);
						y_next = ny_next*Dy + (int )(Dy/2);
						XDrawLine( dpy, XtWindow(Wbox), greengc, x_cur, y_cur, x_next, y_next );
					} /*draws lines to next layer */
			}/*all rectangles finished in current layer */
	}/* all layers finished */
        XFlush(dpy);
} /* D type */ else {
                dist_x = (int )(TOP_LEV_WID / (max_layers+1));
                XClearWindow(dpy, XtWindow(Wbox));
                for(lay=0;lay<max_layers;lay++){
                	dist_y_cur = (int )(TOP_LEV_HEI / (CFTable[lay]+2));
	                for(y=dist_y_cur;y<=dist_y_cur*CFTable[lay];y+=dist_y_cur){
        	        	if( lay != 0)
                			for(i=1;i<=CFTable[lay-1];i++)
						XDrawLine(dpy, XtWindow(Wbox),(lay%2==0 ? redgc:graygc), lay*dist_x+X_OFF,y, (lay-1)*dist_x+X_OFF, dist_y_pre*i);
                	    	XFillArc(dpy,XtWindow(Wbox),bluegc,lay*dist_x+X_OFF-(int)(DIAMETER/2),y-(int)(DIAMETER/2),DIAMETER,DIAMETER,0,360*64);
                	}
			dist_y_pre = dist_y_cur;
		}
	        XFlush(dpy);
} /* A TYPE*/

}
	

