        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "SMain.h"

FILE	*fin,
	*fhistory;

void		DrawInput(void);
void		DrawOutput(void);

void	InputPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg		arg[10];
	int 		i=0, a,b;
	char 		str[30],
			label[30];

if( Network_Not_Mapped ) {
	        ErrorHandler(41, NOT_MAPPED_YET, 0);
	                return;
}
fin = NULL;
fhistory = NULL;

CalculateStructSizes();

if( Type[0] == DISCRETE ){

	i = 0;
	XtSetArg(arg[i], XtNwidth, (Dimension )83 );i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )130);i++;
 	XtSetArg(arg[i], XtNx, (Position )50);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.input.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.input.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )150);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputCanvasPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.output.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.output.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )(170+Sizes.input.window.x));i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputOutputPopup, arg, i);

	
	for(i=0;i<CFTable[0];i++)	DigitalTempExaminationData[i] = examination[i];

	XtPopup( InputPopup,XtGrabNonexclusive );
	XtPopup( InputCanvasPopup, XtGrabNonexclusive ); /* so i can access both windows otherwise it blocks */
	XtPopup( InputOutputPopup, XtGrabNonexclusive );
	
	XtAddEventHandler( InputCanvasPopup, ButtonPressMask, FALSE, InputWidgetEventHandler, (Opaque )NULL );
	XtAddEventHandler( InputCanvasForm, ExposureMask, False, InputExposureHandler, NULL);
	XtAddEventHandler( InputOutputForm, ExposureMask, False, InputExposureHandler, NULL);

} else {

	i = 0;
/*	scanf("%d %d", &a, &b);*/
	XtSetArg(arg[i], XtNwidth, (Dimension )115);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )165);i++;
 	XtSetArg(arg[i], XtNx, (Position )50);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputAnalogPopup, arg, i);

	i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )120);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )24*CFTable[max_layers-1]+1);i++;
        XtSetArg(arg[i], XtNx, (Position )410);i++;
        XtSetArg(arg[i], XtNy, (Position )50);i++;
        XtSetValues( InputAnalogOutputPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.output.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.output.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )600);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputOutputPopup, arg, i);

        InputAnalogAscOutput = (Widget *)calloc(CFTable[max_layers-1]+2, sizeof(Widget));
        for(i=0;i<CFTable[max_layers-1];i++){
        	sprintf(label, "platamon %d", i);
        	InputAnalogAscOutput[i] = XtVaCreateManagedWidget(label,asciiTextWidgetClass,InputAnalogOutputForm, NULL);
	}
	strcpy(str,"Node:0 ");
        XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
	sprintf(str, "%lf", examination[0]);
        XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);
                        
	AnalogNodePointer = 0;

	for(i=0;i<CFTable[0];i++)	AnalogTempExaminationData[i] = examination[i];

	XtPopup( InputAnalogPopup, XtGrabNonexclusive );
	XtPopup( InputAnalogOutputPopup, XtGrabNonexclusive );
	XtPopup( InputOutputPopup, XtGrabNonexclusive );
}	
}

	
void	InputAllRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* all black press all white */
	int i, x, y;

	AllFlag = NOT(AllFlag);
	
	XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR(AllFlag, redgc, whitegc), 0,0, Sizes.input.window.x, Sizes.input.window.y);
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

	for(i=0;i<CFTable[0];i++)	DigitalTempExaminationData[i] = (double )AllFlag;

	XFlush(dpy);
}

void	InputAnalogNextRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	char	str[20];
	
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(InputAnalogAscBox, arg, 1);
	AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */

	sprintf(str, "%lf",AnalogTempExaminationData[ (AnalogNodePointer>=(CFTable[0]-1) ? AnalogNodePointer-=(CFTable[0]-1):++AnalogNodePointer) ]);
	XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);	

	sprintf(str, "Node:%d ", AnalogNodePointer);
	XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
}

void	InputAnalogPreviousRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg     arg[1];
	String 	string;
	char	str[20];
	
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(InputAnalogAscBox, arg, 1);
        AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */

        /* put the one in the list assuming u can proceed the pointer */
	sprintf(str, "%lf",  AnalogTempExaminationData[ (AnalogNodePointer<=0 ? AnalogNodePointer+=(CFTable[0]-1):--AnalogNodePointer) ]);
	XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);

	/* indicate the node # */
	sprintf(str, "Node:%d ", AnalogNodePointer);
	XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
	XFlush(dpy);
}
	
void	InputStartRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR((int )examination[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
			
	for(i=0;i<CFTable[0];i++) DigitalTempExaminationData[i] = examination[i]; /* because event handler works and before start is pressed */
	
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
		
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}


void	InputApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
        Neuron  n = NULL;
        char dummy[2], filename[70];
	String	string;
	Arg	arg[1];
        int i, j;

	
if( Type[0] == DISCRETE )	{
	for(i=0;i<CFTable[0];i++) examination[i] = DigitalTempExaminationData[i];

	Examination();

} else {
        XtSetArg(arg[0], XtNstring, &string);
        XtGetValues(InputAnalogAscBox, arg, 1);
        AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */
        
	for(i=0;i<CFTable[0];i++) 	examination[i] = AnalogTempExaminationData[i];

	Examination();
	DrawOutput();		
}
}

void	InputExposureHandler( Widget w, caddr_t unused, register XEvent *event)
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR((int )DigitalTempExaminationData[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
			
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
		
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}
	
void	InputWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{
	int x, y, box;
	
	x = event->xbutton.x / Sizes.input.box.x;
	y = event->xbutton.y / Sizes.input.box.y; /* the box we are in */
	box = x + y*inpwid;
	
	if( DigitalTempExaminationData[ box ] == (double )WHITE ){
		XFillRectangle( dpy, XtWindow( InputCanvasForm ), redgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( InputCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempExaminationData[ box ] = (double )RED;
	} else {
		XFillRectangle( dpy, XtWindow( InputCanvasForm ), whitegc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( InputCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempExaminationData[ box ] = (double )WHITE;
	}
	
	XFlush(dpy);

}


void	InputPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i;
	
	if( Type[0] == DISCRETE ){
		XtPopdown( InputOutputPopup );
		XtPopdown( InputCanvasPopup );
		XtPopdown( InputPopup );
	} else	{
		for(i=0;i<CFTable[max_layers-1];i++)
				XtDestroyWidget(InputAnalogAscOutput[i]);
	
		free(InputAnalogAscOutput);
		
		XtPopdown( InputOutputPopup );
		XtPopdown( InputAnalogOutputPopup );
		XtPopdown( InputAnalogPopup );

	}
}
	



void	InputFilePopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[10];
	int	i=0;


	if( (fhistory=fopen("history","w")) == NULL )
		ErrorHandler(93, FILE_OPEN_ERROR, 0);

	i = 0;
	XtSetArg(arg[i], XtNwidth, (Dimension )111 );i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )130);i++;
 	XtSetArg(arg[i], XtNx, (Position )300);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputFilePopup, arg, i);

	XtPopup( InputFilePopup,XtGrabNonexclusive );
}


void	InputFileLoadRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[2];
	String	string;
	char	*buffer,
		dummy[50];

	if( (buffer=(char *)calloc(20, sizeof(char))) == NULL )
		ErrorHandler(89, MALLOC_ERROR, 0);
		
        XtSetArg(arg[0], XtNstring, &string);
        XtGetValues(InputFileNameAscBox, arg, 1);

	if( (fin=fopen(string, "r")) == NULL ){
		ErrorHandler(89, FILE_OPEN_ERROR, 0);
		return;
	}
	
/*	fgets(buffer, SAFE_LINE, fin);
	if( (buffer[0]!='%')  )
		ErrorHandler(89, WRONG_PARAMETERS, -1);

	sprintf(dummy, "\n\nFile '%s' has %d lines-input patterns.\0",  string, atoi(++buffer));
	DisplayError(dummy);
*/
}

void	InputFileStepRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i;

	if( fin == NULL ){
		ErrorHandler(91, FILE_READ_ERROR, 0);
		return;
	}
	
	if( feof(fin) ){
		DisplayError("\n\nEnd of file reached while reading input data file.\0");
		return;
	}
	
if( Type[0] == DISCRETE )	{

	for(i=0;i<CFTable[0];i++)
		fscanf( fin, "%lf", &(DigitalTempExaminationData[i]) );
	for(i=0;i<CFTable[max_layers-1];i++)
			fscanf(fin, "%lf", &(desired[i]));
	for(i=0;i<CFTable[0];i++) examination[i] = DigitalTempExaminationData[i];
	DrawInput();
	Examination();
	

} else {

	for(i=0;i<CFTable[0];i++)
		fscanf( fin, "%lf", &(AnalogTempExaminationData[i]) );
	for(i=0;i<CFTable[max_layers-1];i++)
			fscanf(fin, "%lf", &(desired[i]));

	for(i=0;i<CFTable[0];i++) 	examination[i] = AnalogTempExaminationData[i];

	Examination();
		
}

}




void	InputFileAllRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i,
		index = 0;

	if( fin == NULL ){
		ErrorHandler(92, FILE_READ_ERROR, 0);
		return;
	}

	rewind(fin);
/*	if( feof(fin) ){
		DisplayError("\n\nEnd of file reached while reading input data file.\0");
		return;
	}
*/
		
if( Type[0] == DISCRETE )	{

	while( !feof(fin) ){
		for(i=0;i<CFTable[0];i++)
			fscanf( fin, "%lf", &(DigitalTempExaminationData[i]) );
        	for(i=0;i<CFTable[0];i++) examination[i] = DigitalTempExaminationData[i];
		DrawInput();
		Examination();
	}
	
} else {

	while( !feof(fin) ){
		for(i=0;i<CFTable[0];i++)
			fscanf( fin, "%lf", &(AnalogTempExaminationData[i]) );
		for(i=0;i<CFTable[max_layers-1];i++)
			fscanf(fin, "%lf", &(desired[i]));
        	for(i=0;i<CFTable[0];i++) examination[i] = AnalogTempExaminationData[i];
		Examination();
		fprintf(fhistory, "Testing Vector: %d. ", index);
		for(i=0;i<CFTable[max_layers-1];i++) fprintf(fhistory, "  RESULT = %s", ( NCP[max_layers-1][i]->sigmoid > 0.5 ? "TRUE":"FALSE" ));
		fprintf(fhistory, "\n");
		index++;
	} /* while */

} /* else type */

}


void	InputFileQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	if( fin != NULL ) fclose( fin );
	if( fhistory != NULL ) fclose( fhistory );

	XtPopdown( InputFilePopup );
	
}


void		DrawInput(void)
{
	int	i, j, x, y;

        for(i=0;i<inpwid;i++)
                for(j=0;j<inphei;j++)
                        XFillRectangle( dpy, XtWindow( InputCanvasForm ),
                                WHICH_COLOR( (int )ROUND_UP(examination[i+j*inpwid]) , redgc, whitegc),
                                i*Sizes.input.box.x, j*Sizes.input.box.y,
                                Sizes.input.box.x, Sizes.input.box.y);
	
	

                /* draw the grid of black lines */
                for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
                        XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */

                for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
                        XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

        XFlush(dpy);
}


void		DrawOutput(void)
{
	int	i, y;

	for(i=0;i<CFTable[max_layers-1];i++)
		XFillRectangle( dpy, XtWindow( InputOutputForm ),
			WHICH_COLOR( (int )ROUND_UP(NCP[max_layers-1][i]->sigmoid) , redgc, whitegc),
                        0, i*Sizes.output.box.y,
                        Sizes.output.box.x, Sizes.output.box.y);

	/* draw the grid of black lines horizontal */
	for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
		XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/

	XFlush(dpy);
}
