        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "SMain.h"

void	RunningPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg             arg[10];
        int             i=0, out;
        char            str[20], label[20];
	

if( Network_Not_Mapped) {
        ErrorHandler(43, NOT_MAPPED_YET, 0);
        return;
}

	out = CFTable[max_layers-1];

	RunningNodeAscLab  = (Widget *)calloc(out, sizeof(Widget));
        RunningRateAscBox  = (Widget *)calloc(out, sizeof(Widget));
        RunningErrorAscBox = (Widget *)calloc(out, sizeof(Widget));

	strcpy(label,"200");max_iters = 200; 
	XtVaSetValues(RunningItersAscLab, XtNstring, label, NULL);

	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )323);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )(25*(out+1) + 165));i++;
        XtSetArg(arg[i], XtNx, (Position )10);i++;
        XtSetArg(arg[i], XtNy, (Position )10);i++;
        XtSetValues( RunningPopup, arg, i);

       	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )ERROR_BOX_X);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )ERROR_BOX_Y);i++;
        XtSetArg(arg[i], XtNx, (Position )350);i++;
        XtSetArg(arg[i], XtNy, (Position )10);i++;
        XtSetValues( RunningErrorCanvasPopup, arg, i);

/*	i = 0;        
        XtSetArg(arg[i], XtNwidth, (Dimension )600);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )400);i++;
        XtSetArg(arg[i], XtNx, (Position )350);i++;
        XtSetArg(arg[i], XtNy, (Position )450);i++;
        XtSetValues( RunningRateCanvasPopup, arg, i);
*/


	for(i=0;i<out+1;i++){ 
		if( i == out ) strcpy(label, "TOTAL VALUES ");
		else sprintf(label, "     %d       ",i);
		RunningNodeAscLab[i]   = XtVaCreateManagedWidget(label,labelWidgetClass,RunningForm,NULL);
		RunningErrorAscBox[i]  = XtVaCreateManagedWidget(label,asciiTextWidgetClass,RunningForm,NULL);
		RunningRateAscBox[i]   = XtVaCreateManagedWidget(label,asciiTextWidgetClass,RunningForm,NULL);
	}


	XtPopup( RunningPopup, XtGrabNonexclusive );
	XtPopup( RunningErrorCanvasPopup, XtGrabNonexclusive );
/*	XtPopup( RunningRateCanvasPopup, XtGrabNonexclusive );*/

	Rheostat = XtVaCreateManagedWidget("Beta",rheostatWidgetClass,RunningForm,NULL);
	RheostatValueBox  = XtVaCreateManagedWidget("Rheo value",asciiTextWidgetClass,RunningForm,NULL);
	XtVaSetValues(RheostatValueBox, XtNstring, beta, NULL);	

	XtAddCallback(Rheostat, XtNnotifyCallback, GetRheostatValue, (XtPointer)Rheostat);
                
	XtAddEventHandler( RunningErrorCanvasPopup, ButtonPressMask, FALSE, RunningInterruptEventHandler, (Opaque )NULL );
 
}

void GetRheostatValue(w, closure, call_data)
Widget w;
XtPointer closure;
XtPointer call_data;
{
	Widget	rheostat = (Widget)closure;
	int 	val;  /*0 to 100*/

	XtVaGetValues(rheostat, XtNvalue, &val, NULL);
	Beta = (double )val * 2.5 / 100.0; /* 0 to 2.5 */
	sprintf(beta,"%lf", Beta);
	XtVaSetValues(RheostatValueBox, XtNstring, beta, NULL);

	return;
}

void	RunningInterruptEventHandler( Widget w, caddr_t unused, register XEvent *event)
{

	RequestedInterrupt = TRUE;
}



void	RunningPopdownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i;

/*	XtPopdown( RunningRateCanvasPopup );*/
	
	
	for(i=0;i<=CFTable[max_layers-1];i++){
		XtDestroyWidget( RunningNodeAscLab[i] );
	        XtDestroyWidget( RunningRateAscBox[i] );
        	XtDestroyWidget( RunningErrorAscBox[i]);
        	XtDestroyWidget( Rheostat );
        	XtDestroyWidget( RheostatValueBox );
	}
	XtPopdown( RunningErrorCanvasPopup );
	XtPopdown( RunningPopup );

	free( RunningNodeAscLab );
	free( RunningRateAscBox );
	free( RunningErrorAscBox);
}


void	CreateTheNeuralNetwork( void )
{
	Neuron	n = NULL;
	int 	i = 0, j=0;


	/* first layer has num_inputs nodes, each has 1 input and next layer nodes outputs , no weights( that is unity gain )  */
	for(i=0;i<CFTable[0];i++){
		if( (n=CreateNeuron(0,i,1,CFTable[1])) == NULL )
	                ErrorHandler(74, CREATE_NEURON_NODE, 0);
	}

	/* Hidden layer(s) */
	for(i=1;i<=max_layers-2;i++)
		for(j=0;j<CFTable[i];j++) {
			if( (n=CreateNeuron(i,j,CFTable[i-1],CFTable[i+1])) == NULL )
				ErrorHandler(74, CREATE_NEURON_NODE, i);
		}

	/* The output nodes  must have inputs as many as the previous node , they must have only one output though */
        for(i=0;i<CFTable[max_layers-1];i++){
		if( (n=CreateNeuron(max_layers-1, i, CFTable[max_layers-2], 1)) == NULL )
                	ErrorHandler(74, CREATE_NEURON_NODE, max_layers-1);
	}

}


void	SetRandomValuesInNetwork( Widget W, XtPointer client_data, XtPointer call_data )
{
	Neuron	n = NULL;
	int 	i, j, k;


	FillRandomArray();
	for(i=0;i<max_layers;i++){
		for(j=0;j<CFTable[i];j++){
			NCP[i][j]->threshold = Random(MAX_THRESH);
			if( i > 0 ){
				for(k=0;k<CFTable[i-1];k++)	(NCP[i][j]->weight)[k] = Random(MAX_WEIGHT);
			}
		        NCP[i][j]->delta  = 0.0;
        		NCP[i][j]->output = 0.0;
        		NCP[i][j]->sigmoid= 0.0;
		}
	}
}

			
void	RunningStartRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	FILE	*file;
        int i, j;
	Neuron  n = NULL;
	char dummy[2], filename[70];
	double **target_data;
	Arg	arg[1];
	String	string;

/* By that point the CFTable should be allocated and  filled up, and the max_layers known, this is done by the GetUserResponse() function */

	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(RunningItersAscLab, arg, 1);

	if( (max_iters = atoi(string)) == 0) max_iters = MAX_ITERS;

	step = (double )ERROR_BOX_X / (double )max_iters;

	XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), greengc, 0, (int )(ERROR_BOX_Y/2), ERROR_BOX_X, (int )(ERROR_BOX_Y/2) );

	Learning();
	
/* By that point the global array-variables are declared and some of them are initialised, now need to fill them up */
 
}


void	RunningClearWindowRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	XClearWindow(dpy, XtWindow(RunningErrorCanvasForm));

	XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), greengc, 0, (int )(ERROR_BOX_Y/2), ERROR_BOX_X, (int )(ERROR_BOX_Y/2) );
	
	XFlush(dpy);
}

