        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include 		"TMain.h"
#include 		"XMain.h"

int     		max_layers, 	/* the maximum number of layers */
			*CFTable, 	/* stores the number of nodes in each layer */
			num_exemplars, 	/* the number of training vectors */
			hidden_nodes, 	/* the number of hidden nodes */
			max_iters;	/* the number of iterations of training */

double			*DigitalTempExaminationData,
			*AnalogTempExaminationData;

struct  A_SIZE  	Sizes;

/* X staff */
XtAppContext		app;
Display			*dpy;
Colormap 		Cmap;

XColor 			Cred,Cblue,
			Cgreen,
			Cblack,
			Cgray,
			Cwhite;

XGCValues 		gcv;

GC 			redgc,
			bluegc,
			greengc,
			blackgc,
			graygc,
			whitegc;

Widget			toplevel, 	/* the toplevel widget */
			Wbox,		/* the toplevel box form */

			AboutButton,	/*Control Panel belongs to the toplevel, box*/
			SetupButton,
			InputButton,
			TrainingButton,
			RunningButton,
			SaveButton,
			QuitButton, 	/* above are the Buttons of the control panel */
	
                        AboutPopup,
                        AboutForm,

 
			SetupPopup,	/* THE SETUP SUB MENU BELONGS TO THE TOPLEVEL */
			SetupForm,	/* the form widget belongs to the above popup */
			SetupLabType,	/* label widgets */
			SetupLabBeta,
			SetupLabLamda,
			SetupLabExempl,
			SetupLabLayers,
			SetupLabInpNodes,
			SetupLabOutNodes, 
			SetupAscType,	/* and the ascii text widgets to enter the values */
			SetupAscBeta,
			SetupAscLamda,
			SetupAscExemplar,
			SetupAscLayers,
		  	SetupAscInpNodes,
			SetupAscOutNodes,
			SetupQuitButton,/* the two command buttons for the setup sub menu to quit or to apply */
			SetupApplyButton, 

			SetupHiddenPopup,/* THE HIDDEN SUB-SUB MENU BELONGS TO THE SETUP-POPUP */
		 	SetupHiddenForm, /* the sub sub menu for hidden layer # */
			*SetupHiddenAsc, /* Ascii Text array to ask nodes in each hidden layer -variable*/
			*SetupHiddenLab, /* ...and their labels	*/
			SetupHiddenDefaultButton, /* three command buttons */
			SetupHiddenQuitButton,
			SetupHiddenApplyButton,

			SetupDigAnaPopup,/* THE DIGITAL/ANALOG SUB SUB MENU BELONGS TO THE TOPLEVEL AND MUST BE QUITED BEFORE ANSWERING THE HIDDEN ABOVE */
			SetupDigAnaForm, /* the sub sub menu for Digital/analog matrix use for both max 8 elems */
			SetupDigAna[8],	 /* the ascii text and label boxes array */
			SetupDigAnaQuitButton, /* three buttons */
			SetupDigAnaDefaultButton,
			SetupDigAnaApplyButton,



/*ONLY IN D TYPE*/	InputPopup,	/* THE INPUT POPUP MENU BELONGS TO THE TOPLEVEL	AND IS USED TO ENTER AN EXAM ARRAY IN DIG OR ANA FORM */
			InputCanvasPopup,/* The canvas popup to draw on it when in digital case, belongs to the TOPLEVEL */

			InputOutputPopup,/* to draw the output, belongs to the toplevel*/
                        InputOutputForm,
			
			InputForm,	 /* the input form for the inputpopup belongs to that and has various control buttons */
			InputCanvasForm, /* belongs to the InputCanvasPopup we draw on it */ 
			InputQuitButton, /* the control buttons */
			InputStartButton,/*Starts up */
			InputAllButton,	 /*sets all red press again all white */
			InputApplyButton,/* svae the pattern */

/*ONLY IN A TYPE */	InputAnalogPopup,/* THE INPUT POPUP FOR ANALOGUE INPUT EXACTLY AS IT WAS FOR D BUT NOW ASKS VALUES*/ 
			InputAnalogForm,
                        InputAnalogOutputPopup,
                        InputAnalogOutputForm,
			InputAnalogQuitButton,
			InputAnalogNextButton,
			InputAnalogPreviousButton,
			InputAnalogApplyButton,
			InputAnalogAscBox,
			InputAnalogAscPointer,/* the analog input */
			*InputAnalogAscOutput, /* RO , the output after apply */

			
/*ONLY IN D TYPE*/	TrainingPopup,  /* THE TRAINING POPUP BELONGS TO TE TOPLEVEL MANY EXEMPLARS */
			TrainingForm,	/* the form of the control panel of the popup belongs to the popup above */
			TrainingInpCanvasPopup, /* there are two areas to draw on: the input and tha ouput canvas*/
			TrainingOutCanvasPopup,
			TrainingInpCanvasForm,
			TrainingOutCanvasForm, 
			TrainingQuitButton, /* the control buttons */
			TrainingStartButton,
			TrainingAllInputButton,
			TrainingAllOutputButton,
			TrainingApplyButton,
			TrainingApplySingleButton, /* this saves single patterns */
			TrainingNextExemplarButton,
			TrainingPreviousExemplarButton,
			TrainingAscExemplar, /* label to tell us which exemplar is on */

/*ONLY IN A TYPE*/	TrainingAnalogPopup, /*THE SAME AS THE ABOVE POPUP BUT FOR THE A TYPE ASKS VALUES */
			TrainingAnalogForm,
			TrainingAnalogQuitButton,
			TrainingAnalogNextInputNodeButton,/* next node for input and output*/
			TrainingAnalogNextOutputNodeButton,
			TrainingAnalogNextExemplarButton, /* next -previous exemplars*/
			TrainingAnalogPreviousExemplarButton,
			TrainingAnalogApplyButton,
			TrainingAnalogAscExemplar, /*RO */
			TrainingAnalogInputAscBox,
			TrainingAnalogInputAscLab,
			TrainingAnalogOutputAscBox,
			TrainingAnalogOutputAscLab, 
		        TrainingAnalogAscInputNode, /*RO */
		        TrainingAnalogAscOutputNode, /*RO */


                        RunningPopup, /* the popup for running routine */
                        RunningForm,

                        RunningErrorCanvasPopup,
                        RunningErrorCanvasForm,

                        RunningRateCanvasPopup,
                        RunningRateCanvasForm,

                        RunningStartButton,
                        RunningQuitButton,
                        RunningCreateButton,
                        RunningRandomButton,
                        RunningXButton,

			RunningItersAscLab,
                        RunningRateLabel,
                        RunningNodeLabel,
                        RunningErrorLabel,
                        *RunningNodeAscLab,
                        *RunningRateAscBox,  /*RO*/
                        *RunningErrorAscBox, /*RO*/


                        FileopsPopup,
                        FileopsForm,
        
                        FileopsQuitButton,
			FileopsSaveParamsButton,
			FileopsLoadParamsButton,
			FileopsSaveTrainingButton,
			FileopsLoadTrainingButton,
                        
                        FileopsNameBox,


			ErrorPopup,
                        ErrorForm;


/* FINISH THE WIDGETS */
		        
char			Type[3], /* ie digital or analogoue input of the ANN */
			Hidden[30][5], /* maximum 30 hidden layers or use pointer */
			beta[10] , lamda[10],
			Exemplars[5], Layers[5],
			InpNodes[5], OutNodes[5], /* this should change some time to be compatible with the neural proc*/	
			InpHei[5], InpWid[5],
			OutHei[5], OutWid[5]; /* if digital type then input and output expressed as HxW*/

int			inphei, inpwid,
			outhei, outwid,
			AllFlag, /* flags used for the red white all paint */
			AllInpFlag,
			AllOutFlag,
			Network_Not_Mapped,
			AnalogNodePointer, /* pointers to show current node and exemplar */
			AnalogNodePointerInput,
			AnalogNodePointerOutput,
			ExemplarPointer;


/* some housekeeping routines */
void			Initialize(void);
void			PutColorMap( void );
void 			XInitialize( int *argcptr, char **argv );
void			CalculateStructSizes( void );



/* create widgets and popups for all the main window buttons and theis contents*/
void			CreateButtonsOfControlPanel(void);
void			CreateTheSetupDialogBox(void);
void			CreateTheInputDialogBox(void);
void			CreateTheTrainingDialogBox(void);
void			CreateTheRunningDialogBox(void);
void			CreateTheFileopsDialogBox(void);
void                    CreateTheErrorHandlerDialogBox(void);
void                    CreateTheAboutDialogBox(void);


/* event handlers for redrawing screen */ 
void			DrawTheNeuralNetwok( void );
void			TopLevelExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			InputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			TrainingInputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
void			TrainingOutputExposureHandler( Widget w, caddr_t unused, register XEvent *event);



/* event handlers for mouse position for digital boxes */
void			InputWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void			TrainingInpWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void			TrainingOutWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );

/* various event handlers */
void			ErrorPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
void			AboutPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );




/* Callback routines for main window buttons */
void			SetupPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			AboutRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			RunningPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			QuitRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the control panel call back routines */


/* Callback routines for Setup popup */
void			SetupApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the setup sub sub menu call backs*/
void			SetupPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the routine that will pop DOWN the setup sub sub menu */

void			SetupHiddenDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupHiddenApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupHiddenPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			SetupDigAnaDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupDigAnaApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
void			SetupDigAnalPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/* Callback routines for Input popup */
void			InputPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputAllRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			InputAnalogNextRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			InputAnalogPreviousRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/* Callback routines for Training popup Digital and analog type*/ 
void			TrainingPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAllInputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAllOutputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingApplySingleRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );

void			TrainingAnalogNextInputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogNextOutputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			TrainingAnalogPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/*callback routines for Running popup */
void	            	RunningStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void	            	RunningPopdownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	SetRandomValuesInNetwork( Widget W, XtPointer client_data, XtPointer call_data );


/*callbackroutines for fileops popup */
void            	FileopsQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	FileopsSaveParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsLoadParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void            	FileopsSaveTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );
void			FileopsLoadTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );


/* thats all for XXXXXXXXXXXXXX */

/* TRANSPUTER EXTERNAL DECLARATIONS */
/* VARIABLES */

Neuron  *NCP;
int     max_layers, 	max_layers_OLD, /* use old when we free and do for loops */
	*CFTable, 	*CFTable_OLD,
	num_exemplars,	num_exemplars_OLD, /* the number of training vectors */
	max_iters,
	DEBUG, CRESET,
	*RandomVector;
double 	Beta, Lamda,           /* the rate of learning as defined in the hebbian rule */
	*examination,
	*single_output;


Channel *message;

struct TRAINING	   	*Training,
		   	*AnalogTempTrainingData,
		   	*DigitalTempTrainingData;

/* FLAGS */
int     First_time_setup_flag,
	CFT_has_changed_flag;
/* 	FUNCTION DECLARATIONS	*/

/*	allocs.c	*/
int 	AllocateChans( /*va_alist*/ );

/* 	ehandler.c	*/
int     ErrorHandler( unsigned function_code, int description, unsigned useful_number );
void 	Quit( int exit_code );
void 	FreeNeuronData( Neuron n );
void    DisplayError( char *str );

/* 	neuron.c	*/
Neuron  CreateNeuron( int layer, int node, int input_number, int output_number );
void    RegisterNeuron( int layer, int node, Neuron n );
int     GetRelativeOffset( int layer, int node );

/* 	calculations.c 	*/
void    HiddenLayerProcessing( Neuron n, int layer, int node, int attrib );
double  f( double sum, double threshold );
void    ParChanOut( Process *p, Channel *c, double data, Channel *safe );
void    OutputLayerProcessing( Neuron n, int node, double *target_data, int target_num, int attrib );
void    FeedInputLayer( int attrib );

/* 	main.c of transputer	*/
double 	Random(  double max );
int	RandomInt( int max_limit );
void    prSER(Process *p, int attribute, char type);
void	prIN( Process *p, int attrib );
void 	prHL( Process *p, int layer, int node, int attrib );
void 	prOUT( Process *p, int node, double *target, int vector_num, int attrib );


void 	TransputerInitialize( void );
void	CreateTheNeuralNetwork( void ); 


/*	fileops.c		*/
void	SaveConfiguration( char filename[70] );
void	LoadConfiguration( char filename[70] );

/* error server */
void	ErrorServer( int attribute, char type );



/* MAIN X PORTING ROUTINES	*/

main( int argc, char **argv )
{

	Initialize();
	TransputerInitialize();
	XInitialize(&argc, argv); /* open our window */

    	XtAppMainLoop(app); /* wait for Button events */
}
