        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include "TMain.h"
#include "XMain.h"


void	ErrorServer(int attribute, char type )
{
/************************************************************************************************
 * The Error Server is a process running in parallel with the input, hidden and output units  	*
 * It accepts the OUTPUT from all output layer nodes and calculates the error, then it displays *
 * the error on the graph									*
 ************************************************************************************************/

	Channel **receive_list;	/* the list of chanels we receive the FP input from. Output Layer nodes*/
	int     *status, chanel = 10000, out, exemp = -1, step, iterations = 0, Break , count, index,
		i, j, x, y, ex_num;
	double	an_input, *the_input,
		TotalError = 0.0, OldError = 0.0,
		TotalRate = 0.0, OldRate = 0.0,
		NormError = 0.0, NormRate = 0.0;
	char	label[20];
	
	out = CFTable[max_layers-1]; 
	step= (int )(ERROR_BOX_X / max_iters);

	if( (receive_list=(Channel **)calloc(out+2, sizeof(Channel *))) == NULL )
		 ErrorHandler( 21, MALLOC_ERROR, 0 );
        if( (status=(int *)calloc( out, sizeof(int) )) == NULL )
		ErrorHandler( 21, MALLOC_ERROR, 1 );
        if( (the_input=(double *)calloc( out, sizeof(double) )) == NULL )
		ErrorHandler( 21, MALLOC_ERROR, 2 );
	for(i=0;i<out;i++)
		if( (receive_list[i]=NCP[GetRelativeOffset(max_layers-1, i)]->out[0]) == NULL )
		 ErrorHandler( 21, MALLOC_ERROR, 3 );
	receive_list[i] = NULL;


	if( attribute == EXAMINATION ){
		max_iters = 1;
		ex_num = 1;
	} else ex_num = num_exemplars;

while( iterations++ < max_iters ){
	exemp = -1;
	while( ++exemp < ex_num ){
		Break = FALSE;count = 0;
		for(i=0;i<out;i++) {
			status[i] = 0;
			if( CRESET ) ChanReset( receive_list[i] );
		}
	        while( !Break ){   
			index = 0;
			do {	
				chanel = ProcSkipAltList( receive_list );
				if( index++ > PROCALT_TIMED_OUT ){
					if( ErrorHandler(21, ACTION_TIMED_OUT, PROCALT_TIMED_OUT) ) index = 0;
                                        else     Quit(0); 
				}
			} while( (chanel < 0) || (chanel >= out) ); /* do */
			if( (chanel < 0) || (chanel > out) )
				ErrorHandler(21, EMPTY_CHAN_LIST,0);

                        if( status[chanel] == 0) {
				ChanIn( receive_list[chanel], &an_input, sizeof(double));
				if( DEBUG )	printf("ER SER GOT DATA %lf at exe=%d, iters=%d\n", an_input, exemp, iterations);
				the_input[chanel] = an_input;
                	        status[chanel] = 1;
				count++;
			} /* status */
			if( count >= out ) Break = TRUE;
		} /* WHILE NOT Break */

		if( attribute == LEARNING ) 
			for(i=0;i<out;i++) 
				TotalError += pow( (Training[exemp].Target[i]-the_input[i]), (double )2.0 );
	
	} /* While exemp: so far we have the total error for 1 iteration, all exemplars */
	TotalError /= num_exemplars;
	if( attribute == LEARNING ){
		sprintf(label, "%d", max_iters-iterations);
		XtVaSetValues(RunningItersAscLab, XtNstring, label, NULL);
		

/*		sprintf(label, "%4.2lf", TotalError);
		XtVaSetValues(RunningErrorAscBox[0], label, NULL);
                sprintf(label, "%4.2lf", TotalRate);
                XtVaSetValues(RunningRateAscBox[0], label, NULL);
*/
		if( iterations < 3 ) {
			TotalRate= NormRate  = (TotalError - OldError) / step;
			OldError = NormError =  TotalError;
			NormRate = ABS( NormRate );
			NormError= ABS( NormError);
		} else {
			TotalRate = (TotalError - OldError) / step;
			XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), redgc,
					step * (iterations -1),
					ERROR_BOX_Y - (int )(ERROR_BOX_Y * (OldError / NormError)),
					step * iterations, 
					ERROR_BOX_Y - (int )(ERROR_BOX_Y *(TotalError / NormError)) );
			XDrawLine( dpy, XtWindow( RunningErrorCanvasForm ), bluegc,
					step * (iterations -1),
					-(int )((ERROR_BOX_Y/2) * (OldRate / NormRate)) + (int )(ERROR_BOX_Y/2),
					step * iterations,
					-(int )((ERROR_BOX_Y/2) * (TotalRate / NormRate)) + (int )(ERROR_BOX_Y/2) );
			XFlush( dpy );
			OldError = TotalError;
		}

	if( iterations % 5 == 0 ) printf("TE = %4.2lf,  TR=%4.2lf at ITER = %d\n", TotalError, TotalRate, iterations);
	TotalError = 0.0;
	OldRate  = TotalRate;
	} else 	{ /* EXAMINATION */
		for(i=0;i<out;i++) single_output[i] = the_input[i];
		if( type =='D' ){
		        for(i=0;i<outwid;i++)
               			for(j=0;j<outhei;j++)
					XFillRectangle( dpy, XtWindow( InputOutputForm ), WHICH_COLOR( (int )ROUND_UP(single_output[i+j*outwid]) , redgc, whitegc), i*Sizes.output.box.x, j*Sizes.output.box.y, Sizes.output.box.x, Sizes.output.box.y);

		        /* draw the grid of black lines */
        		for(x=0;x<Sizes.output.window.x;x+=Sizes.output.box.x)
                		XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, x, 0, x, Sizes.output.window.y); /* vertical */

	       		for(y=0;y<Sizes.output.window.y;y+=Sizes.output.box.y)
	                	XDrawLine( dpy, XtWindow( InputOutputForm ), blackgc, 0, y, Sizes.output.window.x, y); /*horizontal*/

	        	XFlush(dpy);
		} else { /* NOW TYPE = A */
			for(i=0;i<CFTable[max_layers-1];i++){
		                sprintf(label, "%4.4lf", single_output[i] );
        		        printf("ANALOG INPUT=%s, po=%p\n", label,InputAnalogAscOutput[i]);
				XtVaSetValues( InputAnalogAscOutput[i], XtNstring, label, NULL );
				XFlush(dpy);
			} /* for loop here */
		} /* else type */
	} /* else examination */

} /* while iteras*/

}
