        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/


#include "XMain.h"
#include "TMain.h"


void	InputPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg		arg[10];
	int 		i=0;
	char 		str[20];

if( Network_Not_Mapped) {
	ErrorHandler(41, NOT_MAPPED_YET, 0);
	return;
}
if( Type[0] == DISCRETE ){

	i = 0;
	CalculateStructSizes();
	XtSetArg(arg[i], XtNwidth, (Dimension )83 );i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )100);i++;
 	XtSetArg(arg[i], XtNx, (Position )50);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.input.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.input.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )150);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputCanvasPopup, arg, i);

	i = 0;
 	XtSetArg(arg[i], XtNwidth, (Dimension )Sizes.output.window.x);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )Sizes.output.window.y);i++;
 	XtSetArg(arg[i], XtNx, (Position )(170+Sizes.input.window.x));i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputOutputPopup, arg, i);

	
	for(i=0;i<CFTable[0];i++)	DigitalTempExaminationData[i] = examination[i];

	XtPopup( InputPopup,XtGrabNonexclusive );
	XtPopup( InputCanvasPopup, XtGrabNonexclusive ); /* so i can access both windows otherwise it blocks */
	XtPopup( InputOutputPopup, XtGrabNonexclusive );
	
	XtAddEventHandler( InputCanvasPopup, ButtonPressMask, FALSE, InputWidgetEventHandler, (Opaque )NULL );
	XtAddEventHandler( InputCanvasForm, ExposureMask, False, InputExposureHandler, NULL);
	XtAddEventHandler( InputOutputForm, ExposureMask, False, InputExposureHandler, NULL);

} else {

	i = 0;
	XtSetArg(arg[i], XtNwidth, (Dimension )115);i++;
 	XtSetArg(arg[i], XtNheight, (Dimension )145);i++;
 	XtSetArg(arg[i], XtNx, (Position )50);i++;
 	XtSetArg(arg[i], XtNy, (Position )50);i++;
 	XtSetValues( InputAnalogPopup, arg, i);


        i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )120);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )24*CFTable[max_layers-1]+1);i++;
        XtSetArg(arg[i], XtNx, (Position )210);i++;
        XtSetArg(arg[i], XtNy, (Position )50);i++;
        XtSetValues( InputAnalogOutputPopup, arg, i);

	if( (InputAnalogAscOutput=(Widget *)calloc(CFTable[max_layers-1], sizeof(Widget))) == NULL )
		ErrorHandler(41, MALLOC_ERROR, 0);

        for(i=0;i<CFTable[max_layers-1];i++)
                InputAnalogAscOutput[i] = XtVaCreateManagedWidget("hello",asciiTextWidgetClass,InputAnalogOutputForm,NULL);

	strcpy(str,"Node:0 ");
        XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
	sprintf(str, "%lf", examination[0]);
        XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);
                        
	AnalogNodePointer = 0;

	for(i=0;i<CFTable[0];i++)	AnalogTempExaminationData[i] = examination[i];

	XtPopup( InputAnalogPopup, XtGrabNonexclusive );
        XtPopup( InputAnalogOutputPopup, XtGrabNonexclusive );
}	
}

	
void	InputAllRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	/* all black press all white */
	int i, x, y;

	AllFlag = NOT(AllFlag);
	
	XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR(AllFlag, redgc, whitegc), 0,0, Sizes.input.window.x, Sizes.input.window.y);
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/

	for(i=0;i<CFTable[0];i++)	DigitalTempExaminationData[i] = (double )AllFlag;

	XFlush(dpy);
}

void	InputAnalogNextRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg	arg[1];
	String	string;
	char	str[20];
	
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(InputAnalogAscBox, arg, 1);
	AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */

	sprintf(str, "%lf",AnalogTempExaminationData[ (AnalogNodePointer>=(CFTable[0]-1) ? AnalogNodePointer-=(CFTable[0]-1):++AnalogNodePointer) ]);
	XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);	

	sprintf(str, "Node:%d ", AnalogNodePointer);
	XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
}

void	InputAnalogPreviousRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	Arg     arg[1];
	String 	string;
	char	str[20];
	
	XtSetArg(arg[0], XtNstring, &string);
	XtGetValues(InputAnalogAscBox, arg, 1);
        AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */

        /* put the one in the list assuming u can proceed the pointer */
	sprintf(str, "%lf",  AnalogTempExaminationData[ (AnalogNodePointer<=0 ? AnalogNodePointer+=(CFTable[0]-1):--AnalogNodePointer) ]);
	XtVaSetValues(InputAnalogAscBox, XtNstring, str, NULL);

	/* indicate the node # */
	sprintf(str, "Node:%d ", AnalogNodePointer);
	XtVaSetValues(InputAnalogAscPointer, XtNstring, str, NULL);
	XFlush(dpy);
}
	
void	InputStartRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR((int )examination[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
			
	for(i=0;i<CFTable[0];i++) DigitalTempExaminationData[i] = examination[i]; /* because event handler works and before start is pressed */
	
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
		
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}


void	InputApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
        Neuron  n = NULL;
        Process ***pHL, **pOUT, *pINP, *pSER;
        char dummy[2], filename[70];
	String	string;
	Arg	arg[1];
        int i, j;

	
if( Type[0] == DISCRETE )	for(i=0;i<CFTable[0];i++) examination[i] = DigitalTempExaminationData[i];
else {
        XtSetArg(arg[0], XtNstring, &string);
        XtGetValues(InputAnalogAscBox, arg, 1);
        AnalogTempExaminationData[ AnalogNodePointer ] = atof(string); /* store existing string */
        
	for(i=0;i<CFTable[0];i++) 	examination[i] = AnalogTempExaminationData[i];
}

	/* Allocate memory for a 2D array of size (max_layers-2 by #of nodes in each layer) to store the process to each hidden layer, pHL is a pointer to that list */
        if( (pHL=(Process ***)calloc(max_layers-2, sizeof(Process **))) == NULL )
                ErrorHandler(55, MALLOC_ERROR, 0);
        for(i=1;i<=max_layers-2;i++)
                if( (pHL[i-1]=(Process **)calloc(CFTable[i], sizeof(Process *))) == NULL )
                         ErrorHandler(55, MALLOC_ERROR, 1);

	/* Allocate memory for a 1D array of size num_outputs=CFTable[max_layers-1] to store all the processes of each output unit , pOUT is a pointer to that list */
        if( (pOUT=(Process **)calloc(CFTable[max_layers-1], sizeof(Process *))) == NULL )
        	ErrorHandler(55, MALLOC_ERROR, 2);

	/* NOW PROCALLOC ALL THE PROCESS TOTAL NUMBER OF PROCESSES ARE:
                        INP LAYER:      1
                        HID LAYER:      (max_layers-2)*(nodes in each layer) ( (max_layers-2)*SumOf(CFTable[1..max_layers-2]) )
                        OUT LAYER:      nodes in output layer( CFTable[max_layers-1] )
                        TOTAL    :      1 + (max_layers-2)*SumOf(CFTable[1..max_layers-2]) + CFTable[max_layers-1]
	*/

	/* Stack Size 1300 bytes worked OK but if something goes wrong this is most likely to be the cause*/
        if( (pINP=ProcAlloc(prIN,STACK_SIZE,2,EXAMINATION, NULL)) == NULL )
                ErrorHandler( 55, ALLOCATE_PROC, -1 );

        for(i=0;i<max_layers-2;i++)
                for(j=0;j<CFTable[i+1];j++)
                        if( (pHL[i][j]=ProcAlloc( prHL, STACK_SIZE, 4, i+1, j, EXAMINATION, NULL )) == NULL )
                                ErrorHandler( 55, ALLOCATE_PROC, i );


        for(i=0;i<CFTable[max_layers-1];i++)
                if( (pOUT[i]=ProcAlloc(prOUT,2*STACK_SIZE,5, i, NULL, 1, EXAMINATION, NULL)) == NULL )
                        ErrorHandler( 55, ALLOCATE_PROC, 200 );


        if( (pSER=ProcAlloc(prSER,STACK_SIZE,3,EXAMINATION, Type[0], NULL)) == NULL )
                ErrorHandler( 55, ALLOCATE_PROC, 300 );


	/* NOW RUN THE PROCESSES IN PARALLEL. GOD HELP US */
        ProcRun(pINP); /* Run the FeedInputs process */

        for(i=0;i<max_layers-2;i++)
                for(j=0;j<CFTable[i+1];j++){
			/*printf(" RUN HIDDEN: (%d,%d)= %p\n", i+1,j,pHL[i][j]);*/
                        ProcRun( pHL[i][j] ); /* Run all the HiddenLayer processes */
        }

        for(i=0;i<CFTable[max_layers-1];i++)
                ProcRun(pOUT[i]); /* Run the OutputLayer process */
        ProcRun(pSER);

for(i=0;i<CFTable[max_layers-1];i++)
        ChanInInt( message ); /* wait until the all the data has been processed */

	/* Clean Processes */
	ProcAllocClean(pINP);

	for(i=0;i<max_layers-2;i++)
                for(j=0;j<CFTable[i+1];j++)
			ProcAllocClean(pHL[i][j] );

        for(i=0;i<CFTable[max_layers-1];i++)
                ProcAllocClean(pOUT[i]);

	ProcAllocClean(pSER);
}

void	InputExposureHandler( Widget w, caddr_t unused, register XEvent *event)
{
	int i, j, x, y;

	/* draw the vector exactly as it was last time */
	for(i=0;i<inpwid;i++)
		for(j=0;j<inphei;j++)
			XFillRectangle( dpy, XtWindow( InputCanvasForm ), WHICH_COLOR((int )DigitalTempExaminationData[i+j*inpwid], redgc, whitegc), i*Sizes.input.box.x, j*Sizes.input.box.y, Sizes.input.box.x, Sizes.input.box.y);
			
	/* draw the grid of black lines */
	for(x=0;x<Sizes.input.window.x;x+=Sizes.input.box.x)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, x, 0, x, Sizes.input.window.y); /* vertical */
		
	for(y=0;y<Sizes.input.window.y;y+=Sizes.input.box.y)
		XDrawLine( dpy, XtWindow( InputCanvasForm ), blackgc, 0, y, Sizes.input.window.x, y); /*horizontal*/
	
	XFlush(dpy);
}
	
void	InputWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{
	int x, y, box;
	
	x = event->xbutton.x / Sizes.input.box.x;
	y = event->xbutton.y / Sizes.input.box.y; /* the box we are in */
	box = x + y*inpwid;
	
	if( DigitalTempExaminationData[ box ] == (double )WHITE ){
		XFillRectangle( dpy, XtWindow( InputCanvasForm ), redgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( InputCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempExaminationData[ box ] = (double )RED;
	} else {
		XFillRectangle( dpy, XtWindow( InputCanvasForm ), whitegc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		XDrawRectangle( dpy, XtWindow( InputCanvasForm ), blackgc, x*Sizes.input.box.x, y*Sizes.input.box.y,Sizes.input.box.x, Sizes.input.box.y);
		DigitalTempExaminationData[ box ] = (double )WHITE;
	}
	
	XFlush(dpy);

}


void	InputPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
	int	i;

	if( Type[0] == DISCRETE ){
		XtPopdown( InputOutputPopup );
		XtPopdown( InputCanvasPopup );
		XtPopdown( InputPopup );
	} else	{
		XtPopdown( InputAnalogOutputPopup );
		XtPopdown( InputAnalogPopup );
		for(i=0;i<CFTable[max_layers-1];i++)
			XtDestroyWidget(InputAnalogAscOutput);

		free(InputAnalogAscOutput);
	}
}
	

