        /********************************************************
         *                                                      *
         *      ARTIFICIAL   NEURAL   NETWORK   SOFTWARE        *
         *                                                      *
         *      By Andrea Hadjiprocopis                         *
         *                                                      *
         *              1992/93                                 *
         *                                                      *
         ********************************************************/

#include <ctype.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xutil.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Command.h>


/* SOME DEFINES */
#define APPNAME "Andrea Hadjiprocopis, This is your life."
#define TOP_LEV_HEI	600 
#define TOP_LEV_WID	800 /* toplevel window dimensions */
#define	DIAMETER	8   /* diameter of neuron circles when drawn */
#define	X_OFF		30  /* x offset when drawing the net on top level window */
#define	Y_OFF		30  /* y offset just to make sure buttons are always untouched */

#define	WHITE		0   /* define the main colours of the digital convention */
#define	RED		1

#define	WIN_X_MIN	50  /* for digital windows and the digital box min and max dimensions */
#define	WIN_X_MAX	800
#define	WIN_Y_MIN	WIN_X_MIN
#define WIN_Y_MAX	500
#define	BOX_X_MIN	20
#define BOX_X_MAX	WIN_X_MIN
#define BOX_Y_MIN	BOX_X_MIN
#define BOX_Y_MAX	BOX_X_MAX /* input output windows for digital input ranges */

#define	ERROR_BOX_X	400
#define	ERROR_BOX_Y	250

/* macros */
#define WHICH_COLOR(data, color_data_is_1, color_data_is_0) ((int )data != WHITE ? color_data_is_1:color_data_is_0)
#define	NOT( x )	((int )x != WHITE ? WHITE:RED)
#define MAX(a,b)        (a >= b ? a:b)


/* external variables */
extern	double			*DigitalTempExaminationData, /* The array to store Temporarily the Input popup D type data*/
				*AnalogTempExaminationData;  /* .... A type of Input popup */



extern	struct  TRAINING   	*AnalogTempTrainingData,  /* The pointer to the struct to store Training A type data Tempor. */
		   		*DigitalTempTrainingData; /*The pointer to the struct to store Training D type data Tempor. */

	   
struct	A_CLASS {
	int	x, y; /*width and height */
};

struct	A_TYPE {
	struct A_CLASS	window, box;
};

struct	A_SIZE {
	struct A_TYPE	input, output;
};
 /* all the above for defining the structure Sizes to store window dimensions(and box )of D type */
extern	struct	A_SIZE	Sizes;


/* X staff */
extern	XtAppContext	app; 	/* Application's context */
extern	Display		*dpy; 	/* Our connection with the X server */
extern	Colormap 	Cmap; 	/* The rest control colors on-screen */
extern	XColor 		Cred,
			Cblue,
			Cgreen,
			Cblack,
			Cgray,
			Cwhite;
extern	XGCValues 	gcv;
extern	GC 		redgc,
			bluegc,
			greengc,
			blackgc,
			graygc,
			whitegc;

extern	Widget		toplevel, 	/* the toplevel widget */
			Wbox,		/* the toplevel box form */

			AboutButton,	/*Control Panel belongs to the toplevel, box*/
			SetupButton,
			InputButton,
			TrainingButton,
			RunningButton,
			SaveButton,
			QuitButton, 	/* above are the Buttons of the control panel */
	
			AboutPopup,
			AboutForm,

			SetupPopup,	/* THE SETUP SUB MENU BELONGS TO THE TOPLEVEL */
			SetupForm,	/* the form widget belongs to the above popup */
			SetupLabType,	/* label widgets */
			SetupLabBeta,
			SetupLabLamda,
			SetupLabExempl,
			SetupLabLayers,
			SetupLabInpNodes,
			SetupLabOutNodes, 
			SetupAscType,	/* and the ascii text widgets to enter the values */
			SetupAscBeta,
			SetupAscLamda,
			SetupAscExemplar,
			SetupAscLayers,
		  	SetupAscInpNodes,
			SetupAscOutNodes,
			SetupQuitButton,/* the two command buttons for the setup sub menu to quit or to apply */
			SetupApplyButton, 

			SetupHiddenPopup,/* THE HIDDEN SUB-SUB MENU BELONGS TO THE SETUP-POPUP */
		 	SetupHiddenForm, /* the sub sub menu for hidden layer # */
			*SetupHiddenAsc, /* Ascii Text array to ask nodes in each hidden layer -variable*/
			*SetupHiddenLab, /* ...and their labels	*/
			SetupHiddenDefaultButton, /* three command buttons */
			SetupHiddenQuitButton,
			SetupHiddenApplyButton,

			SetupDigAnaPopup,/* THE DIGITAL/ANALOG SUB SUB MENU BELONGS TO THE TOPLEVEL AND MUST BE QUITED BEFORE ANSWERING THE HIDDEN ABOVE */
			SetupDigAnaForm, /* the sub sub menu for Digital/analog matrix use for both max 8 elems */
			SetupDigAna[8],	 /* the ascii text and label boxes array */
			SetupDigAnaQuitButton, /* three buttons */
			SetupDigAnaDefaultButton,
			SetupDigAnaApplyButton,



/*ONLY IN D TYPE*/	InputPopup,	/* THE INPUT POPUP MENU BELONGS TO THE TOPLEVEL	AND IS USED TO ENTER AN EXAM ARRAY IN DIG OR ANA FORM */
			InputCanvasPopup,/* The canvas popup to draw on it when in digital case, belongs to the TOPLEVEL */
			
			InputOutputPopup,/* to draw the output, belongs to the toplevel*/
			InputOutputForm,
			InputForm,	 /* the input form for the inputpopup belongs to that and has various control buttons */
			InputCanvasForm, /* belongs to the InputCanvasPopup we draw on it */ 
			InputQuitButton, /* the control buttons */
			InputStartButton,/*Starts up */
			InputAllButton,	 /*sets all red press again all white */
			InputApplyButton,/* svae the pattern */

/*ONLY IN A TYPE */	InputAnalogPopup,/* THE INPUT POPUP FOR ANALOGUE INPUT EXACTLY AS IT WAS FOR D BUT NOW ASKS VALUES*/ 
			InputAnalogForm,
			InputAnalogOutputPopup,
			InputAnalogOutputForm,
			InputAnalogQuitButton,
			InputAnalogNextButton,
			InputAnalogPreviousButton,
			InputAnalogApplyButton,
			InputAnalogAscBox,
			InputAnalogAscPointer,/* the analog input */
			*InputAnalogAscOutput, /* RO , the output after apply */


			
/*ONLY IN D TYPE*/	TrainingPopup,  /* THE TRAINING POPUP BELONGS TO TE TOPLEVEL MANY EXEMPLARS */
			TrainingForm,	/* the form of the control panel of the popup belongs to the popup above */
			TrainingInpCanvasPopup, /* there are two areas to draw on: the input and tha ouput canvas*/
			TrainingOutCanvasPopup,
			TrainingInpCanvasForm,
			TrainingOutCanvasForm, 
			TrainingQuitButton, /* the control buttons */
			TrainingStartButton,
			TrainingAllInputButton,
			TrainingAllOutputButton,
			TrainingApplyButton,
			TrainingApplySingleButton, /* this saves single patterns */
			TrainingNextExemplarButton,
			TrainingPreviousExemplarButton,
			TrainingAscExemplar, /* label to tell us which exemplar is on */

/*ONLY IN A TYPE*/	TrainingAnalogPopup, /*THE SAME AS THE ABOVE POPUP BUT FOR THE A TYPE ASKS VALUES */
			TrainingAnalogForm,
			TrainingAnalogQuitButton,
			TrainingAnalogNextInputNodeButton,/* next node for input and output*/
			TrainingAnalogNextOutputNodeButton,
			TrainingAnalogNextExemplarButton, /* next -previous exemplars*/
			TrainingAnalogPreviousExemplarButton,
			TrainingAnalogApplyButton,
			TrainingAnalogAscExemplar, /*RO */
			TrainingAnalogInputAscBox,
			TrainingAnalogInputAscLab,/*lab*/
			TrainingAnalogOutputAscBox,
			TrainingAnalogOutputAscLab, /* label for out value */ 
		        TrainingAnalogAscInputNode, /*RO */
		        TrainingAnalogAscOutputNode, /*RO */



		        RunningPopup, /* the popup for running routine */
		        RunningForm,

		        RunningErrorCanvasPopup,
		        RunningErrorCanvasForm,

		        RunningRateCanvasPopup,
		        RunningRateCanvasForm,

		        RunningStartButton,
		        RunningQuitButton,
			RunningCreateButton,
			RunningRandomButton,
			RunningXButton,

			RunningItersAscLab, /*WR*/
		        RunningRateLabel,
		        RunningNodeLabel,
		        RunningErrorLabel,
		        *RunningNodeAscLab,
		        *RunningRateAscBox,  /*RO*/
		        *RunningErrorAscBox, /*RO*/



		        FileopsPopup,
			FileopsForm,
        
		        FileopsQuitButton,
			FileopsSaveParamsButton,
			FileopsLoadParamsButton,
			FileopsSaveTrainingButton,
			FileopsLoadTrainingButton,
						
			FileopsNameBox,

			ErrorPopup,
			ErrorForm;
							        
/* FINISH THE WIDGETS */
		        
extern	char	Type[3], /* ie digital or analogoue input of the ANN */
		Hidden[30][5], /* maximum 30 hidden layers or use pointer */
		beta[10] , lamda[10],
		Exemplars[5], Layers[5],
		InpNodes[5], OutNodes[5], /* this should change some time to be compatible with the neural proc*/	
		InpHei[5], InpWid[5],
		OutHei[5], OutWid[5]; /* if digital type then input and output expressed as HxW*/
extern	int	inphei, inpwid,
		outhei, outwid,
		AllFlag, /* flags used for the red white all paint */
		AllInpFlag,
		AllOutFlag,
		Network_Not_Mapped,
		AnalogNodePointer, /* pointers to show current node and exemplar */
		AnalogNodePointerInput,
		AnalogNodePointerOutput,
		ExemplarPointer;


/* some housekeeping routines */
extern	void		Initialize(void);
extern	void		PutColorMap( void );
extern	void 		XInitialize( int *argcptr, char **argv );
extern	void		CalculateStructSizes( void );



/* create widgets and popups for all the main window buttons and theis contents*/
extern	void		CreateButtonsOfControlPanel(void);
extern	void		CreateTheSetupDialogBox(void);
extern	void 		CreateTheInputDialogBox(void);
extern	void		CreateTheTrainingDialogBox(void);
extern	void		CreateTheRunningDialogBox(void);
extern	void		CreateTheFileopsDialogBox(void);
extern  void            CreateTheErrorHandlerDialogBox(void);
extern  void            CreateTheAboutDialogBox(void);


/* event handlers for redrawing screen */ 
extern	void		DrawTheNeuralNetwok( void );
extern	void		TopLevelExposureHandler( Widget w, caddr_t unused, register XEvent *event);
extern	void		InputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
extern	void		TrainingInputExposureHandler( Widget w, caddr_t unused, register XEvent *event);
extern	void		TrainingOutputExposureHandler( Widget w, caddr_t unused, register XEvent *event);



/* event handlers for mouse position for digital boxes */
extern	void		InputWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
extern	void		TrainingInpWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
extern	void		TrainingOutWidgetEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );


/* various event handlers */
extern  void            ErrorPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );
extern  void            AboutPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont );

/* Callback routines for main window buttons */
extern	void		AboutRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		SetupPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		InputPopUpRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		RunningPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		FileopsPopupRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		QuitRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the control panel call back routines */



/* Callback routines for Setup popup */
extern	void		SetupApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the setup sub sub menu call backs*/
extern	void		SetupPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data ); /* the routine that will pop DOWN the setup sub sub menu */

extern	void		SetupHiddenDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
extern	void		SetupHiddenApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
extern	void		SetupHiddenPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );

extern	void		SetupDigAnaDefaultRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
extern	void		SetupDigAnaApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data ); 
extern	void		SetupDigAnalPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/* Callback routines for Input popup */
extern	void		InputPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		InputApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		InputAllRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		InputStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );

extern	void		InputAnalogNextRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		InputAnalogPreviousRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/* Callback routines for Training popup Digital and analog type*/ 
extern	void		TrainingPopDownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingAllInputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingAllOutputRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingApplyRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingApplySingleRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		TrainingPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );

extern  void		TrainingAnalogNextInputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern  void		TrainingAnalogNextOutputNodeRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern  void		TrainingAnalogNextExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern  void		TrainingAnalogPreviousExemplarRoutine( Widget W, XtPointer client_data, XtPointer call_data );



/*callback routines for Running popup */

/* thats all */
extern  void		RunningStartRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern  void		RunningPopdownRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern  void		SetRandomValuesInNetwork( Widget W, XtPointer client_data, XtPointer call_data );


/*callbackroutines for fileops popup */
extern 	void		FileopsQuitRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		FileopsSaveParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		FileopsLoadParamsRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		FileopsSaveTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );
extern	void		FileopsLoadTrainingRoutine( Widget W, XtPointer client_data, XtPointer call_data );
 

