#include "XMain.h"
#include "TMain.h"

void    TopLevelExposureHandler( Widget w, caddr_t unused, register XEvent *event)
{
        DrawTheNeuralNetwork();
}       

 
void    QuitRoutine(Widget W, XtPointer client_data, XtPointer call_data )
{
        exit(0);
}
        
void    XInitialize( int *argcptr, char **argv )   
{
        Arg arg[10];
        int i = 0;
        
        app = XtCreateApplicationContext();
        dpy = XtOpenDisplay(app,NULL,APPNAME,"app",NULL,0,argcptr,argv);
        XtSetArg(arg[i],XtNwidth,TOP_LEV_WID); i++;
        XtSetArg(arg[i],XtNheight,TOP_LEV_HEI); i++;

        
        /*the top level */
/*      toplevel = XtAppCreateShell(APPNAME,"app",applicationShellWidgetClass, dpy,arg,i);*/
        
        toplevel = XtVaAppInitialize( &app, APPNAME, NULL, 0, argcptr,argv /*,fallback_resources*/, NULL, NULL);
        XtSetValues(toplevel,arg,i);

        /* the window*/
        Wbox = XtVaCreateManagedWidget("Box",boxWidgetClass,toplevel,NULL);
        
        XtAddEventHandler(Wbox, ExposureMask, False, TopLevelExposureHandler, NULL);
        PutColorMap();
        
        CreateButtonsOfControlPanel();   
        CreateTheSetupDialogBox();
        CreateTheInputDialogBox();
        CreateTheTrainingDialogBox();
        CreateTheRunningDialogBox();
	CreateTheFileopsDialogBox();
	CreateTheErrorHandlerDialogBox();
	CreateTheAboutDialogBox();
 
        XtRealizeWidget(toplevel); /* make the windows appear */
        do ; while( !XtIsRealized(Wbox));
}



void    PutColorMap( void )
{
        Cmap = DefaultColormap(dpy, DefaultScreen(dpy));

        XParseColor(dpy, Cmap, "Red", &Cred);
        XParseColor(dpy, Cmap, "Blue", &Cblue);
        XParseColor(dpy, Cmap, "White", &Cwhite);
        XParseColor(dpy, Cmap, "Gray", &Cgray);
        XParseColor(dpy, Cmap, "Black", &Cblack);
        XParseColor(dpy, Cmap, "Green", &Cgreen);
        
        XAllocColor(dpy, Cmap, &Cred);
        XAllocColor(dpy, Cmap, &Cblue);
        XAllocColor(dpy, Cmap, &Cgreen);
        XAllocColor(dpy, Cmap, &Cwhite);
        XAllocColor(dpy, Cmap, &Cgray);
        XAllocColor(dpy, Cmap, &Cblack);
        
        gcv.foreground = Cred.pixel;
        redgc = XtGetGC(Wbox, GCForeground, &gcv);

        gcv.foreground = Cblue.pixel;
        bluegc = XtGetGC(Wbox, GCForeground, &gcv);
 
        gcv.foreground = Cgreen.pixel;
        greengc = XtGetGC(Wbox, GCForeground, &gcv);
 
        gcv.foreground = Cwhite.pixel;
        whitegc = XtGetGC(Wbox, GCForeground, &gcv);
        
        gcv.foreground = Cgray.pixel;
        graygc = XtGetGC(Wbox, GCForeground, &gcv);
        
        gcv.foreground = Cblack.pixel;
        blackgc = XtGetGC(Wbox, GCForeground, &gcv);
        
        
}
void    CalculateStructSizes( void )
{
/* runs only when type = Digital */
        
        int num;
        
        if( Type[0] != DISCRETE ) return;
 
        /*take num max */
        /*mult by Nx, number of nodes horiz */
        /* is result less than win_max? - repeat by decreasing the value num until condition satisfied*/
 
        num = BOX_X_MAX * inpwid;
        while( num > WIN_X_MAX )        num -= BOX_X_MAX;
        Sizes.input.box.x    = (int )(num / inpwid);
        Sizes.input.window.x = Sizes.input.box.x * inpwid;

        num = BOX_Y_MAX * inphei;
        while( num > WIN_Y_MAX )        num -= BOX_Y_MAX;   
        Sizes.input.box.y    = (int )(num / inphei);
        Sizes.input.window.y = Sizes.input.box.y * inphei;  
        
        num = BOX_X_MAX * outwid;
        while( num > WIN_X_MAX )        num -= BOX_X_MAX;
        Sizes.output.box.x    = (int )(num / outwid);
        Sizes.output.window.x = Sizes.input.box.x * outwid;
        
        num = BOX_Y_MAX * outhei;
        while( num > WIN_Y_MAX )        num -= BOX_Y_MAX;   
        Sizes.output.box.y    = (int )(num / outhei);
        Sizes.output.window.y = Sizes.input.box.y * outhei;

}       
         
void    Initialize( void )
{
	char	def[5];
        int 	i;

	NCP = NULL;        
        strcpy(Type,"D");   
        strcpy(beta,"1.4");     Beta                    = BETA;
        strcpy(lamda,"1.0");    Lamda                   = LAMDA;
        strcpy(Layers,"3");     max_layers              = MAX_LAYERS;max_layers_OLD = max_layers;
        strcpy(Exemplars,"2");  num_exemplars           = NUM_EXEMPLARS;num_exemplars_OLD = num_exemplars;
        strcpy(InpHei, "4");    inphei                  = INPUT_NODES_HEIGTH;
        strcpy(InpWid, "1");    inpwid                  = INPUT_NODES_WIDTH;
        strcpy(OutHei, "2");    outhei                  = OUTPUT_NODES_HEIGHT;
        strcpy(OutWid, "1");    outwid                  = OUTPUT_NODES_WIDTH;
        
        
	if( (CFTable=(int *)calloc(max_layers+1, sizeof(int))) == NULL )
		ErrorHandler(22, MALLOC_ERROR, 0);
        for(i=1;i<max_layers-1;i++) CFTable[i] = HIDDEN_NODES;
	sprintf(def, "%d", HIDDEN_NODES);
        for(i=0;i<max_layers-2;i++)     strcpy(Hidden[i], def); /* the default # of nodes in each hidden layer*/
	sprintf(def, "%d", INPUT_NODES);
        strcpy(InpNodes,def);   CFTable[0]              = INPUT_NODES;
	sprintf(def, "%d", OUTPUT_NODES);
        strcpy(OutNodes, def);   CFTable[max_layers-1]   = OUTPUT_NODES;


	First_time_setup_flag = TRUE;
	CFT_has_changed_flag  = FALSE;
	Network_Not_Mapped    = TRUE;
        AllFlag         = 0;
        AllOutFlag      = 0;
        AllInpFlag      = 0;
        AnalogNodePointer = 0;
        AnalogNodePointerInput = 0;
        AnalogNodePointerOutput = 0;

}       


void    AboutRoutine( Widget W, XtPointer client_data, XtPointer call_data )
{
        Arg     arg[4];
        int     i;
	char    *msg = "        Neural  Networks  Software\n\n          Andreas  Hadjiprocopis\n\n                 1992/93";

        i = 0;
        XtSetArg(arg[i], XtNwidth, (Dimension )295);i++;
        XtSetArg(arg[i], XtNheight, (Dimension )155);i++;
        XtSetArg(arg[i], XtNx, (Position )350);i++;
        XtSetArg(arg[i], XtNy, (Position )250);i++;

        XtSetValues( AboutPopup, arg, i);

        XtVaSetValues(AboutForm, XtNstring, msg, NULL);

        XtPopupSpringLoaded( AboutPopup );
        XtAddEventHandler( AboutPopup, ButtonPressMask, FALSE, AboutPressMouseToQuitEventHandler, (Opaque )NULL );
	XBell( dpy, 30 );
	XFlush( dpy );	
}

void    AboutPressMouseToQuitEventHandler( Widget w, XtPointer unused, register XEvent *event, Boolean *cont )
{

	XtPopdown(AboutPopup);
	XBell( dpy, 40 );
	XFlush( dpy );	
}


